/******************************************************************************
 * {]p̡GFjt@²EF@2004/02
 *
 * nĥ GPL vAҦ{XҥiۥѴGέק
 * Ҧ{]p̤TФHOd :)
 ******************************************************************************/


#ifndef FRM_TELNET_CPP
#define FRM_TELNET_CPP

#include <wx/caret.h>

#include <wx/notebook.h>
#include <wx/icon.h>
#include <wx/imaglist.h>
#include <wx/scrolwin.h>
#include <wx/fontdlg.h>
#include <wx/utils.h>	//::wxGetHostName()
#include <wx/choicdlg.h>	//::wxGetMultipleChoice()

//ϥ include {̭
#include "icon/close.xpm"
#include "icon/connecting.xpm"
#include "icon/connected.xpm"
#include "icon/message.xpm"
enum { ICON_CLOSE, ICON_CONNECTING, ICON_CONNECTED, ICON_MESSAGE };


#include "scd_tabctrl.cpp"
#include "scd_telnet.cpp"
#include "telnet_panel.cpp"

#include "frm_editterm.cpp"
#include "sites_frame.cpp"
#include "scd_gtk_textctrl.cpp"
// ============================================================================

class BBS_Frame : public wxFrame
{
public:
 	Telnet_Panel panel;
	wxToolBar *tb;

#if defined(__WXGTK__)
	SCD_TextCtrl textctrl;
#endif

private:
	SCD_Telnet *now_telnet;
	wxScrolledWindow scrollwin;

	wxTimer timer;
 	SCD_TabCtrl tab;
 	wxImageList image_list;

	wxMenu *editMenu;
	wxMenu *menuBookmark;

	bool blFullScreen;

	bool isClosed;
	
	void ReloadBookmark();	//ŪҦC

	void ShowPreviousTelnet() 	{	tab.ShowPreviousTab();	}
	void ShowNextTelnet() 	{	tab.ShowNextTab();	}

	int  getNowTelnetIndex()	{	return tab.GetSelection();	}
	int  getTelnetCount()		{	return tab.GetItemCount();	}
	
public:
	// ctor(s)
	BBS_Frame(const wxString& title, const wxPoint& pos, const wxSize& size,
	long style = wxDEFAULT_FRAME_STYLE | wxNO_FULL_REPAINT_ON_RESIZE );
	~BBS_Frame();

	void ShowSpecifiedTerminal(int id = -1);
	void DeleteTerminal(int id = -1 );
	void SetTerminalFont(wxFont fnt);
	void FitTerminalSize();	//brΧܩΤsuɥiIs禡, jpH terminal ]wӧ

	void connect( wxString addr );
	void connect(wxString ip, int port, wxString name);
	void connect(SiteInfo &si);

	void SendCanedMessage(int id);

	// event handlers (these functions should _not_ be virtual)

	void OnSocketEvent( wxSocketEvent &e );

	void OnTimer(wxTimerEvent& event);

	void OnMouseRightDown(wxMouseEvent& event)
	{
		if( event.GetId() == 666 )	//ϥΪ̦bsuҤWIk, QYӳsu
		{
			int i = tab.getTabUnderMouse( event.GetX() , event.GetY() );
			if( i < 0 )	return;
	
			DeleteTerminal(i);
		}
	}
	void OnMouseRightUp(wxMouseEvent& event)
	{
		PopupMenu( editMenu , event.GetX() + panel.GetPosition().x , event.GetY() + panel.GetPosition().y );
	}

	void OnMouseLeftUp(wxMouseEvent& event)
	{
/*
		if( now_telnet != NULL && now_telnet->isSelected() )
		{
			PopupMenu( editMenu , event.GetX() + panel.GetPosition().x , event.GetY() + panel.GetPosition().y );
			now_telnet->CancelSelection();
		}
*/
		if(now_telnet)	now_telnet->CopySelectionToClipboard(false);
	}
	void OnMouseMiddleDown(wxMouseEvent& event)
	{
		if(now_telnet == NULL)	return;
		now_telnet->PasteFromClipboard(true);
	}


	void OnConnection(wxCommandEvent& event);

	void OnCopy(wxCommandEvent& event);
	void OnCopy_withANSI(wxCommandEvent& event);
	void OnPaste(wxCommandEvent& event);
	void OnPaste_withANSI(wxCommandEvent& event);

	void OnSelectAll(wxCommandEvent& event);
	void OnOpenSelectionAsHyperlink(wxCommandEvent& event)
	{	if(now_telnet)	now_telnet->OpenSelectionAsHyperlink();	}
	void OnInputLine(wxCommandEvent& event);

	void OnAddBookmark(wxCommandEvent& event);
	void OnEditBookmark(wxCommandEvent& event);
	void OnBookmark(wxCommandEvent& event);

	void OnSetting(wxCommandEvent& event);
	void OnTool(wxCommandEvent& event);

	void OnGoTab(wxCommandEvent& event);
	void OnCanedMessage(wxCommandEvent& event);

	void FullScreen();

	void OnChar(wxKeyEvent& event);
	void OnKeyDown(wxKeyEvent& event);

	void OnMenuOpen(wxMenuEvent& event)
	{
#if defined(__WXGTK__)	
		wxFocusEvent e;
		panel.OnFocus(e);	//GTK U alt ɷ|y telnet_panel::isAltDown P_~A]bo̩Is telnet_panel::OnFocus Ϥ٭
#endif
	}
	void OnFocus(wxFocusEvent& event)
	{
#if defined(__WXGTK__)
		panel.OnFocus(event);	//GTK U alt+tab ɷ|y telnet_panel::isAltDown P_~A]bo̩Is telnet_panel::OnFocus Ϥ٭
//fprintf(stderr, "SetFocus\n");
//		textctrl.SetFocus();
#endif
	}

	void OnQuit(wxCommandEvent& event);
	void OnAbout(wxCommandEvent& event);
	void OnClose(wxCloseEvent& event);
	void OnActivate(wxActivateEvent& event);

	void OnTabChanged(wxNotebookEvent& event);

	void recalcVarFontSize();	//sp panel i̤jrjp
	void OnResize(wxSizeEvent& event);

	void OnOpenAnsiEditor(wxCommandEvent& event)
	{	ShowAnsiEditor();	}
	
	void OnUpdate_UI(wxUpdateUIEvent& event);
	void UpdateToolbarUI();

private:
	// any class wishing to process wxWindows events must use this macro
	DECLARE_EVENT_TABLE()
};

// IDs for the controls and the menu commands
enum
{
	Minimal_Quit = 1,

	MENU_ABOUT_BEGIN = wxID_ABOUT,
	MENU_ABOUT = wxID_ABOUT,	//Note NOT TO MODIFY THIS
	MENU_ABOUT_MESSAGE_CODE,
	MENU_ABOUT_GOWEB,	//sn
	MENU_ABOUT_GOMAIL,	//HH BBMan n]p
	MENU_ABOUT_END,

	MENU_ANSIEDITOR,

	MENU_BEGIN = 66,

	MENU_CONNECTION_BEGIN,
	MENU_OPENSITELIST,
	MENU_QUICKCONNECT,
	MENU_CLOSECONNECTION,
	MENU_DELETETELNET,
	MENU_RECONNECT,
	MENU_GOPREV,
	MENU_GONEXT,
	MENU_GOUSERSPECIFIEDTAB,
	MENU_FULLSCREEN,
	MENU_LOGINWHENSTART,
	MENU_PASSWD,
	MENU_CONNECTION_END,

	MENU_COPY,
	MENU_COPY_ANSI,
	MENU_PASTE,
	MENU_PASTE_ANSI,
	
	MENU_SELECTALL,
	MENU_OPEN_SELECTION_AS_LINK,
	MENU_INPUT_LINE,

	MENU_SETTING_BEGIN,
	MENU_FONT,
	MENU_LINK_PROGRAM,
	MENU_AUTO_REPLY,
	MENU_EDIT_CANNED_MESSAGE,
	MENU_NAWS,
	MENU_LINE_WRAPED_LENGTH,
	MENU_MULTIBYTEWORDDETECTION,
	MENU_MESSAGE_SOUND,
	MENU_ALWAYS_HIGHLIGHT,
	MENU_AUTO_RECONNECT,
	MENU_PREVENT_DISCONNECT,
	MENU_SETTING_END,

	MENU_TOOL_BEGIN,
	MENU_LOCKSCREEN,
	MENU_EXPORT_SETTING,
	MENU_IMPORT_SETTING,
	MENU_TOOL_END,

	MENU_GOTAB_1,
	MENU_GOTAB_9 = MENU_GOTAB_1 + 8 ,

	MENU_CANNED_MESSAGE_1,
	MENU_CANNED_MESSAGE_12 = MENU_CANNED_MESSAGE_1 + 11 ,

	MENU_ADDBOOKMARK,
	MENU_EDITBOOKMARK,
	MENU_BOOKMARK_BEGIN,		//o@wnb̫@
	MENU_BOOKMARK_END = MENU_BOOKMARK_BEGIN + 1000	//̦he\ 1000 Ӯ
};

// ----------------------------------------------------------------------------
// event tables and other macros for wxWindows
// ----------------------------------------------------------------------------

BEGIN_EVENT_TABLE(BBS_Frame, wxFrame)

	EVT_NOTEBOOK_PAGE_CHANGED( 666, BBS_Frame::OnTabChanged )
	EVT_SIZE(BBS_Frame::OnResize)

	EVT_SOCKET(666 , BBS_Frame::OnSocketEvent)

	EVT_TIMER(0, BBS_Frame::OnTimer)

	EVT_LEFT_UP(BBS_Frame::OnMouseLeftUp)
	EVT_RIGHT_DOWN(BBS_Frame::OnMouseRightDown)
	EVT_RIGHT_UP(BBS_Frame::OnMouseRightUp)
	EVT_MIDDLE_DOWN(BBS_Frame::OnMouseMiddleDown)

	EVT_KEY_DOWN(BBS_Frame::OnKeyDown)
	EVT_CHAR(BBS_Frame::OnChar)

	EVT_SET_FOCUS(BBS_Frame::OnFocus)
	EVT_MENU_OPEN(BBS_Frame::OnMenuOpen)


	EVT_MENU_RANGE(MENU_CONNECTION_BEGIN, MENU_CONNECTION_END, BBS_Frame::OnConnection)

	EVT_MENU(MENU_COPY, BBS_Frame::OnCopy)
	EVT_MENU(MENU_COPY_ANSI, BBS_Frame::OnCopy_withANSI)
	EVT_MENU(MENU_PASTE, BBS_Frame::OnPaste)
	EVT_MENU(MENU_PASTE_ANSI, BBS_Frame::OnPaste_withANSI)

	EVT_MENU(MENU_SELECTALL, BBS_Frame::OnSelectAll)
	EVT_MENU(MENU_OPEN_SELECTION_AS_LINK, BBS_Frame::OnOpenSelectionAsHyperlink)
	EVT_MENU(MENU_INPUT_LINE, BBS_Frame::OnInputLine)

	EVT_MENU(MENU_ADDBOOKMARK,  BBS_Frame::OnAddBookmark)
	EVT_MENU(MENU_EDITBOOKMARK,  BBS_Frame::OnEditBookmark)
	EVT_MENU_RANGE(MENU_BOOKMARK_BEGIN, MENU_BOOKMARK_END, BBS_Frame::OnBookmark)

	EVT_MENU_RANGE(MENU_SETTING_BEGIN, MENU_SETTING_END, BBS_Frame::OnSetting)
	EVT_MENU_RANGE(MENU_TOOL_BEGIN, MENU_TOOL_END, BBS_Frame::OnTool)

	EVT_MENU(MENU_ANSIEDITOR, BBS_Frame::OnOpenAnsiEditor)

	EVT_MENU_RANGE(MENU_GOTAB_1, MENU_GOTAB_9, BBS_Frame::OnGoTab)
	EVT_MENU_RANGE(MENU_CANNED_MESSAGE_1, MENU_CANNED_MESSAGE_12, BBS_Frame::OnCanedMessage)

	EVT_MENU_RANGE(MENU_ABOUT_BEGIN, MENU_ABOUT_END, BBS_Frame::OnAbout)
	EVT_MENU(Minimal_Quit,  BBS_Frame::OnQuit)

	EVT_UPDATE_UI_RANGE( MENU_SETTING_BEGIN , MENU_SETTING_END , BBS_Frame::OnUpdate_UI)
	EVT_UPDATE_UI( MENU_LOGINWHENSTART , BBS_Frame::OnUpdate_UI)
	EVT_UPDATE_UI( MENU_FULLSCREEN , BBS_Frame::OnUpdate_UI)

	EVT_ACTIVATE(BBS_Frame::OnActivate)
	EVT_CLOSE(BBS_Frame::OnClose)
	
END_EVENT_TABLE()

BBS_Frame::~BBS_Frame()
{
	panel.Show(false);
	panel.SetTelnet(NULL);
	//delete all telnet ...
	for(int i=0;i<tab.GetItemCount();i++)
	{
		SCD_Telnet *t = (SCD_Telnet*) tab.GetItemData(i);
		delete t;
	}		
#ifdef __WXGTK__
	destroy_CopyPasteDialog();
#endif
}

BBS_Frame::BBS_Frame(const wxString& title, const wxPoint& pos, const wxSize& size, long style)
	   : wxFrame(NULL, -1, title, pos, size, style)
{
	// set the frame icon
//	SetIcon(wxICON(mondrian));
	//

#if wxUSE_MENUS
	// create a menu bar
	wxMenuBar *menuBar = new wxMenuBar();

	wxMenu *menuFile = new wxMenu;
	menuFile->Append(MENU_OPENSITELIST, _T("} BBS M... (&L)") );
	menuFile->Append(MENU_QUICKCONNECT, _T("ֳtsu... (&Q)\tAlt-Q") );
	menuFile->AppendSeparator();
	menuFile->Append(MENU_CLOSECONNECTION, _T("_su (&D)\tAlt-D") );
	menuFile->Append(MENU_DELETETELNET, _T("su (&W)\tAlt-W") );
	menuFile->Append(MENU_RECONNECT, _T("ssu (&R)\tAlt-R") );
	menuFile->AppendSeparator();
	menuFile->Append(MENU_GOPREV, _T("W@ӳsu (&Z)\tAlt-Z") );
	menuFile->Append(MENU_GONEXT, _T("U@ӳsu (&X)\tAlt-X") );
	menuFile->Append(MENU_GOUSERSPECIFIEDTAB, _T("wsu \tF5") );
	menuFile->AppendSeparator();
	menuFile->AppendCheckItem(MENU_FULLSCREEN, _T("ù (&F)\tAlt-Enter") );

	wxMenu *menuLogin = new wxMenu;
	menuLogin->AppendCheckItem(MENU_LOGINWHENSTART, _T("CҰʵ{ܵnJe (&L)") );
	menuLogin->Append(MENU_PASSWD, _T("קnJKX (&M)") );
	menuFile->Append(0, _T("nJ]w"), menuLogin);

	menuFile->AppendSeparator();
	menuFile->Append(Minimal_Quit, _T("}{ (&P)\tAlt-F4"));
	menuBar->Append(menuFile, _T("su(&O)"));

	editMenu = new wxMenu;
	editMenu->Append(MENU_COPY , _T("ƻs (u¤r) (&C)\tAlt-C") );
	editMenu->Append(MENU_PASTE, _T("KW (u¤r) (&V)\tAlt-V") );
	editMenu->AppendSeparator();
	editMenu->Append(MENU_COPY_ANSI , _T("ƻs (]tANSIm) (&B)\tCtrl-Alt-C") );
	editMenu->Append(MENU_PASTE_ANSI, _T("KW (]tANSIm) (&P)\tCtrl-Alt-V") );
	editMenu->AppendSeparator();
	editMenu->Append(MENU_OPEN_SELECTION_AS_LINK , _T("NrWsö} (&H)") );
	editMenu->AppendSeparator();
	editMenu->Append(MENU_SELECTALL , _T("ӵe (&A)\tAlt-A") );
	editMenu->AppendSeparator();
	editMenu->Append(MENU_INPUT_LINE, _T("J... (&L)\tAlt-L") );
	menuBar->Append(editMenu, _T("s(&E)"));

	menuBookmark = new wxMenu;
	menuBookmark->Append(MENU_ADDBOOKMARK, _T("[Jڪ̷R (&A)") );
	menuBookmark->Append(MENU_EDITBOOKMARK, _T("ק / R ڪ̷R (&E)") );
	menuBookmark->AppendSeparator();
	menuBar->Append(menuBookmark, _T("ڪ̷R (&F)"));

	wxMenu *menuOption = new wxMenu;
	menuOption->Append(MENU_FONT, _T("r... (&F)") );
	menuOption->Append(MENU_LINK_PROGRAM, _T("]wWsp{ (&P)") );
	menuOption->Append(MENU_MESSAGE_SOUND, _T("yɼnɮ... (&S)") );
	menuOption->Append(MENU_AUTO_REPLY, _T("mɦ۰ʦ^Фy... (&M)") );
	menuOption->Append(MENU_EDIT_CANNED_MESSAGE, _T("sֳtT... (&E)") );
	menuOption->Append(MENU_LINE_WRAPED_LENGTH, _T("KWrɨC̤j (&W)") );
	menuOption->AppendCheckItem(MENU_NAWS, _T("Ұʪù (&L)") );
	menuOption->AppendCheckItem(MENU_MULTIBYTEWORDDETECTION, _T("Ұʥثesur (&D)\tF12") );
	menuOption->AppendCheckItem(MENU_ALWAYS_HIGHLIGHT, _T("HGצr") );
	menuOption->AppendSeparator();
	menuOption->Append(MENU_AUTO_RECONNECT, _T("۰ʭssu (&A)") );
	menuOption->Append(MENU_PREVENT_DISCONNECT, _T("b (_u) (&D)") );
	menuBar->Append(menuOption, _T("]w (&S)"));
	
	wxMenu *ansieditorMenu = new wxMenu;
	ansieditorMenu->Append(MENU_ANSIEDITOR, _T("}ANSIrs边 (&E)") );
	menuBar->Append(ansieditorMenu, _T("ANSIs (&N)"));

	wxMenu *menuTool = new wxMenu;
	menuTool->Append(MENU_LOCKSCREEN, _T("ù (ѼȮ}y) \tAlt-P") );
//	menuTool->Append(MENU_EXPORT_SETTING, _T("ץX]w") );
//	menuTool->Append(MENU_IMPORT_SETTING, _T("פJ]w") );
	menuBar->Append(menuTool, _T("u (&T)"));

	wxMenu *helpMenu = new wxMenu;
	helpMenu->Append(MENU_ABOUT, _T(" BBMan (&A)\tF1") );
	helpMenu->Append(MENU_ABOUT_MESSAGE_CODE, _T(" BBMan 榡ưT (&F)") );
	helpMenu->AppendSeparator();
	helpMenu->Append(MENU_ABOUT_GOWEB, _T("s BBMan n (&W)") );
	helpMenu->Append(MENU_ABOUT_GOMAIL, _T("HH BBMan n]p (&M)") );
	menuBar->Append(helpMenu, _T("(&H)"));


	SetMenuBar(menuBar);
	


    int k;
    int height;
    wxBitmap icons[17];
    wxBitmap tbimg( _T("toolbar.bmp") , wxBITMAP_TYPE_BMP );
    height = tbimg.GetHeight();
    for(k=0;k<17;k++)
        icons[k] = tbimg.GetSubBitmap( wxRect( k*height, 0, height, height ) );

    tb = CreateToolBar();
    tb->SetToolBitmapSize(wxSize(height,height));
    tb->SetWindowStyle( wxTB_FLAT | wxTB_DOCKABLE | wxTB_HORIZONTAL );
    tb->SetMargins(3, 3);
    k = 0;
    tb->AddTool( MENU_OPENSITELIST , wxEmptyString , icons[k++] , _T("BBS M") );
    tb->AddTool( MENU_QUICKCONNECT , wxEmptyString , icons[k++] , _T("ֳtsu") );
    tb->AddSeparator();
    tb->AddTool( MENU_CLOSECONNECTION , wxEmptyString , icons[k++] , _T("_su") );
    tb->AddTool( MENU_RECONNECT , wxEmptyString , icons[k++] , _T("ssu") );
    tb->AddTool( MENU_DELETETELNET , wxEmptyString , icons[k++] , _T("su") );
    tb->AddTool( MENU_ADDBOOKMARK , wxEmptyString , icons[k++] , _T("[Jڪ̷R") );
    tb->AddSeparator();
    tb->AddTool( MENU_COPY , wxEmptyString , icons[k++] , _T("ƻs (¤r)") );
    tb->AddTool( MENU_COPY_ANSI , wxEmptyString , icons[k++] , _T("ƻs (ANSI mX)") );
    tb->AddTool( MENU_PASTE_ANSI , wxEmptyString , icons[k++] , _T("KW (ANSI mX)") );
    tb->AddCheckTool( MENU_MULTIBYTEWORDDETECTION , wxEmptyString , icons[k++] , wxNullBitmap , _T("۰ʰ줸r") );
    tb->AddSeparator();
    tb->AddTool( MENU_FONT , wxEmptyString , icons[k++] , _T("r]w") );
    k++;//  tb->AddTool( MENU_OPENSITELIST , wxEmptyString , icons[k++] , wxEmptyString );
    tb->AddCheckTool( MENU_FULLSCREEN , wxEmptyString , icons[k++] , wxNullBitmap , _T("ù") );
    k++;    //tb->AddTool( MENU_OPENSITELIST , wxEmptyString , icons[k++] , wxEmptyString );
    k++;    //tb->AddTool( MENU_OPENSITELIST , wxEmptyString , icons[k++] , wxEmptyString );
    tb->AddTool( MENU_LOCKSCREEN , wxEmptyString , icons[k++] , _T("{W") );
    tb->AddSeparator();
    tb->AddTool( MENU_ABOUT , wxEmptyString , icons[k++] , _T(" BBMan") );
    tb->Realize();
    SetToolBar(tb);



#endif // wxUSE_MENUS

#if wxUSE_STATUSBAR
	// create a status bar just for fun (by default with 1 pane only)
//#if ! defined(__WXGTK__)
	CreateStatusBar();
	SetStatusText( GetStatusBarText() );
	SetStatusBarPane(-1);
//#endif
#endif // wxUSE_STATUSBAR

	//]w terminal r
//	SetFont( GetCurrentFont() );


	ReloadBookmark();


	//l telnet 
 	now_telnet = NULL;
	
	//l timer
	timer.SetOwner(this, 0);
	timer.Start(600);
	

	image_list.Create(16, 16);
	image_list.Add( wxIcon(close_xpm) );
	image_list.Add( wxIcon(connecting_xpm) );
	image_list.Add( wxIcon(connected_xpm) );
	image_list.Add( wxIcon(message_xpm) );

	tab.Create(this, 666);
	tab.Init();
	tab.SetImageList( & image_list );


	panel.Create(this, -1, wxDefaultPosition, wxDefaultSize , wxNO_FULL_REPAINT_ON_RESIZE );
	panel.SetFont( GetFont() );

#if defined(__WXGTK__)
	textctrl.Create( & panel );
#endif

	


	//]wֳt
//#if defined(__WXMSW__) || defined(__WXMAC__)
	wxAcceleratorEntry entries[100];
	int ac = 0;
//	for(int i=0;i<12;i++)	entries[ac++].Set(wxACCEL_CTRL,  WXK_F1 + i , MENU_CANNED_MESSAGE_1 + i );
	for(int i=0;i<9;i++)	entries[ac++].Set(wxACCEL_ALT,  '1' + i , MENU_GOTAB_1 + i );
	entries[ac++].Set(wxACCEL_ALT,  '0' , MENU_GOUSERSPECIFIEDTAB );
//	entries[ac++].Set(wxACCEL_CTRL, WXK_LEFT, MENU_GOPREV );
//	entries[ac++].Set(wxACCEL_CTRL, WXK_RIGHT, MENU_GONEXT );

	entries[ac++].Set(wxACCEL_ALT,  'T' , MENU_QUICKCONNECT );


	wxAcceleratorTable accel( ac , entries);
	panel.SetAcceleratorTable(accel);
//#endif

	//


	blFullScreen = false;
	isClosed = false;
}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
void BBS_Frame::connect(wxString ip, int port, wxString name = wxEmptyString )
{
	SiteInfo si;
	si.ip = ip;
	si.port = port;
	si.name = name;
	connect(si);
}
// ----------------------------------------------------------------------------
void BBS_Frame::connect( wxString addr )	// ex: telnet://ptt.twbbs.org:23
{
	if( addr.First( _T("telnet://") ) == 0 )	addr = addr.Right( addr.Length() - 9 );
	else if( addr.First( _T("bbs://") ) == 0 )	addr = addr.Right( addr.Length() - 6 );

	int port = 23;
	if( addr.Find( ':' ) != -1 )
	{
		addr.AfterFirst(':').ToLong( (long*) &port );
		addr = addr.BeforeFirst(':');
	}
	connect( addr, port );
}
// ----------------------------------------------------------------------------
void BBS_Frame::connect(SiteInfo &si)
{
/*
	if( ip.Index(':') != wxNOT_FOUND )
	{
   		long ll = 0;
   		ip.AfterLast(':').ToLong(&ll);
   		port = (int)ll;
   		ip = ip.BeforeLast(':');
	}
*/

	int next_tab_index = -1;

	wxString tab_title;
 	if( si.name == wxEmptyString )	tab_title = si.ip;
 	else	tab_title = si.name;

	if( now_telnet == NULL || ! now_telnet->IsDisconnected() )
	{	//pGثe telnet ƥ == 0 , Ϊ  ثe telnet suO
		//hsW@ӳsu
 		now_telnet = new SCD_Telnet(&panel);
		now_telnet->SetOnLinkClickedFunc( OnLinkClicked );

 		tab.InsertItem(0, tab_title, ICON_CONNECTING, now_telnet);
 		next_tab_index = tab.GetItemCount() - 1;
	}
	else
	{
  		next_tab_index = tab.GetSelection();

		tab.SetItemText( next_tab_index , tab_title );
		tab.SetItemImage( next_tab_index, ICON_CONNECTING );
	}

	now_telnet->connect( si.ip, si.port , si.name , si.username , si.password , si.message );

	tab.SetSelection( next_tab_index );
}
// ----------------------------------------------------------------------------
void BBS_Frame::OnTabChanged(wxNotebookEvent& event)
{
	if( isClosed )	return;

  	if( event.GetSelection() < 0 )
   	{
   		now_telnet = NULL;
   		panel.SetTelnet(NULL);
   		SetTitle(_T("BBMan"));
   	}
   	else
   	{
		SCD_Telnet *t;
		t = (SCD_Telnet*) tab.GetItemData( tab.GetSelection() );
		now_telnet = t;

		panel.SetTelnet(t);

		if( t->getName() == wxEmptyString )
			SetTitle( _T("BBMan - ") + t->getIP() );
		else
			SetTitle( _T("BBMan - ") + t->getName() + _T(" [ ") + t->getIP() + _T(" ]") );

//		FitTerminalSize();
	}

	panel.SetFocus();
	UpdateToolbarUI();
#if defined(__WXGTK__)
//	textctrl.SetFocus();
#endif

}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
void BBS_Frame::OnCopy(wxCommandEvent& event)
{
	if(now_telnet == NULL)	return;
	now_telnet->CopySelectionToClipboard(false);
	now_telnet->CancelSelection();
}
// ----------------------------------------------------------------------------
void BBS_Frame::OnCopy_withANSI(wxCommandEvent& event)
{
	if(now_telnet == NULL)	return;
	now_telnet->CopySelectionToClipboard(true);
	now_telnet->CancelSelection();
}
// ----------------------------------------------------------------------------
void BBS_Frame::OnPaste(wxCommandEvent& event)
{
	if(now_telnet == NULL)	return;
	now_telnet->PasteFromClipboard(false);
}
// ----------------------------------------------------------------------------
void BBS_Frame::OnPaste_withANSI(wxCommandEvent& event)
{
	if(now_telnet == NULL)	return;
	now_telnet->PasteFromClipboard(true);
}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
void BBS_Frame::OnSelectAll(wxCommandEvent& event)
{
	if(now_telnet == NULL)	return;
	now_telnet->SelectAll();
}
void BBS_Frame::OnInputLine(wxCommandEvent& event)
{
	if(now_telnet == NULL)	return;
#ifdef __WXGTK__
	wxString line = GetMultilineTextFromUser( _T("пJneXT"), _T("J"), this );
#else
	wxString line = wxGetTextFromUser( _T("пJneXT"), _T("J"), _T("") );
#endif
	if( ! line.IsEmpty() )
		now_telnet->Paste( wxStringToCharPtr(line) , true );
}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------


// event handlers

void BBS_Frame::OnActivate(wxActivateEvent& event)
{	panel.SetFocus();	}
// ----------------------------------------------------------------------------
void BBS_Frame::OnQuit(wxCommandEvent& WXUNUSED(event))
{	Close();	}	//o| BBS_Frame  OnClose event
// ----------------------------------------------------------------------------
void BBS_Frame::OnClose(wxCloseEvent& event)
{
	bool hasConnection = false;
	for(int i=0;i<tab.GetItemCount();i++)
	{
		if( ((SCD_Telnet*)tab.GetItemData(i))->IsConnected() )
		{
			hasConnection = true;
			break;
		}
	}

	if( event.CanVeto() )	//pGOtαj
		if( hasConnection )	//pGثesu, h߰ݬO_nثesu
			if( wxNO == wxMessageBox( _T("ثe٦subϥΤATwn{H") , _T("T{"), wxYES_NO ) )
			{
				event.Veto();	//t 
				return;
			}

	isClosed = true;

	//xsjp
	cfg.Write( GetUserConfigPath(_T("/setting/win_geo/fullscreen")) , IsFullScreen()?1:0 );
 	if( ! IsFullScreen() )
	{
		wxSize  ws = GetSize();
		wxPoint wp = GetPosition();
		cfg.Write( GetUserConfigPath(_T("/setting/win_geo/left")) , wp.x );
		cfg.Write( GetUserConfigPath(_T("/setting/win_geo/top")) , wp.y );
		cfg.Write( GetUserConfigPath(_T("/setting/win_geo/width")) , ws.GetWidth() );
		cfg.Write( GetUserConfigPath(_T("/setting/win_geo/height")) , ws.GetHeight() );
	}
	//

	this->Destroy();	//			
}
// ----------------------------------------------------------------------------
void BBS_Frame::OnAbout(wxCommandEvent& event)
{
	int id = event.GetId();
	switch(id)
	{
		case MENU_ABOUT :	ShowAbout();	break;
		case MENU_ABOUT_MESSAGE_CODE : 	wxMessageBox( _T("BBMan 榡ưTiHAb [su۰ʰeXr]  [eX۩wT] ɫweX@ǯSX\r\n\r\nҦSXҥH׽u \\ }Y\r\n\\nG[Enter]\r\n\\^?GCtrl+? ( Ҧp \\^R  Ctrl+R )\r\n\\#{UDLR}GWUk ( \\#UGW ) (\\#LG)\r\n\\p3GȰ 3  ( Ʀri 1~9 )\r\n\\\\G׽u \\\r\n\r\nҦpbnJ ptt ɧAiHw۰ʰeXrG\\p3username\\npassword\\n\\n\\#D\\#D\\n\\n \r\n( Ȱ 3  -> X username -> [Enter] -> X password -> [Enter] nJ -> [Enter] -> ⦸ [Down] -> ⦸ [Enter] ϥΪ̿ )") , _T(" BBMan 榡ưT") );
			break;
		case MENU_ABOUT_GOWEB :	OpenHyperlink("http://nccu.edu.tw/92753008/BBMan/");	break;
		case MENU_ABOUT_GOMAIL :	OpenHyperlink("mailto:jakky1@pchome.com.tw?subject=[BBMan] ĳ / D^");	break;
	}
}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
void BBS_Frame::ReloadBookmark()
{
	int i;

	//RҦ menuitem

	i = MENU_BOOKMARK_BEGIN;
	while(1)
	{
		wxMenuItem *item;
		item = menuBookmark->FindItem(i);
		if( item == NULL )	break;
		menuBookmark->Destroy( item );
		i++;
	}


	//sإߩҦ menuitem

	SiteInfo si;
	i = MENU_BOOKMARK_BEGIN;

	cfg.SetPath( GetUserConfigPath(_T("/bookmark/")) );
	wxString name, str;
	long id;
	bool ret;
	ret = cfg.GetFirstEntry( name , id );
	while( ret )
	{
		if( cfg.Read( name , &str ) )
		{
			si.Set(str);
			menuBookmark->Append( i++, si.name, si.Get() );
		}
		ret = cfg.GetNextEntry( name , id );
	}
	
}
// ----------------------------------------------------------------------------
void BBS_Frame::OnEditBookmark(wxCommandEvent& event)
{
	cfg.SetPath( GetUserConfigPath(_T("/bookmark/")) );

	wxArrayString site_name_list;

	SiteInfo si;
	wxString name, str;
	long id;
	bool ret;

	ret = cfg.GetFirstEntry( name , id );
	while( ret )
	{
		if( cfg.Read( name , &str ) )
		{
			si.Set(str);
			site_name_list.Add( si.name );
		}
		ret = cfg.GetNextEntry( name , id );
	}

	name = wxGetSingleChoice( _T("An BBS  s / R ʧ@H") , _T("s/Rx")
				, site_name_list );
	if( name.IsEmpty() )	return;	//pGϥΪ̿ [Cancel] hX

	int action = wxMessageBox( _T("Anﯸx [ ") + name + _T(" ] ذʧ@H\r\n\r\n[YES]s [NO]R [Cancel]") , _T("s / Rx") , wxYES_NO | wxCANCEL );
	if( action == wxCANCEL )	return;
	else if( action == wxYES )
	{
		wxString str;
		if( ! cfg.Read( name , &str ) )
		{	wxMessageBox( _T("]wŪ~") );	return;	}

		si.Set( str );
		if( ShowSiteEditDialog(_T("[Jڪ̷R"), &si) )
		{
			if( si.name != name )	//pGϥΪ̭קsuW
   			{
				if( cfg.Exists( si.name ) )
				{	wxMessageBox( _T("xW [ ") + si.name + _T(" ] wgQϥΤF, ʧ@") );	return;	}
				else
					cfg.DeleteEntry( name );
			}

			cfg.Write( si.name , si.Get() );
			wxMessageBox( _T("s觹") );
		}
	}
	else if( action == wxNO )
	{
		cfg.DeleteEntry( name );
		wxMessageBox( _T("x [ ") + name + _T(" ] wR") );
	}

	cfg.Flush();
	ReloadBookmark();	//sJҸT
}
// ----------------------------------------------------------------------------
void BBS_Frame::OnAddBookmark(wxCommandEvent& event)
{
	if(now_telnet == NULL)	return;

	SiteInfo si;
	si.ip = now_telnet->getIP();
	si.port = now_telnet->getPort();
	si.name = now_telnet->getName();
	if( si.name == wxEmptyString )	si.name = si.ip;

	if( ShowSiteEditDialog(_T("[Jڪ̷R"), &si) )
	{
		cfg.SetPath( GetUserConfigPath(_T("/bookmark/")) );
		if( cfg.Exists( si.name ) )	wxMessageBox( _T("W٬ ") + si.name + _T(" xwsb") );
		else
		{
			cfg.Write( si.name, si.Get() );
			cfg.Flush();
			ReloadBookmark();
		}
	}
}
// ----------------------------------------------------------------------------
void BBS_Frame::OnBookmark(wxCommandEvent& event)
{
	wxMenuItem *item = menuBookmark->FindItem( event.GetId() );
	if( item )
	{
		SiteInfo si;
		si.Set( item->GetHelp() );
		connect(si);
	}
	else
		wxMessageBox(_T("bookmark not found"));
}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
void BBS_Frame::OnTimer(wxTimerEvent& event)
{
	for(int i=0;i<tab.GetItemCount();i++)
	{
		SCD_Telnet *t = (SCD_Telnet*) tab.GetItemData(i);
		if( t->getServerIdleTime() > 60*3 )	//pGӳsumL[
 			t->UserSend("\x1bOA\x1bOB");	//Ctrl + L
	}

	if(now_telnet != NULL)
		now_telnet->setBlinkCharVisibility( ! now_telnet->getBlinkCharVisibility() );
}
// ----------------------------------------------------------------------------
void BBS_Frame::OnSocketEvent( wxSocketEvent &e )
{
	//note : b򨺨Ǥ@suWN_u server supU,
	//i wxSOCKET_LOST |b wxSOCKET_CONNECTION e
	//ҥH٬On socket::IsConnected() T

	SCD_Telnet *t = (SCD_Telnet*) e.GetClientData();
	if( t == NULL )	return;
	int i = tab.GetItemIndex(t);
	if( i < 0 )	return;	//pG i < 0 , NϥΪ̭nDR tab

	if( e.GetSocketEvent() == wxSOCKET_CONNECTION
		|| e.GetSocketEvent() == wxSOCKET_LOST )
	{
		if( t->IsConnected() )	//pGwgsWuF
			tab.SetItemImage( i , ICON_CONNECTED );
		else	//pGsu_F
		{
			if( tab.GetItemImage(i) == ICON_CONNECTING )	//pGO]sW_u (]pGOsW~_u, imageid ӵ ICON_CONNECTED , pG imageid == ICON_CONNECTING hNSsWL)
			{
				tab.SetItemImage( i , ICON_CLOSE );
				t->parse( "\x1b[1;1H\x1b[1;5;33;43m su ( iODȮɰAȩάOҿJ}~ ) \x1b[m" );
			}
			else if( ! t->isUserClosed() && t->getConnectTime() < 10 )	//pGsuɶQNQ_u, hssu
			{
				tab.SetItemImage( i , ICON_CONNECTING );
				t->parse( "\x1b[1;1H\x1b[1;5;33;43m ۰ʭssu ... \x1b[m\x1b[1;1H" );
				t->reconnect();
			}
			else
			{
				tab.SetItemImage( i , ICON_CLOSE );
				t->parse( "\x1b[1;1H\x1b[1;5;33;43m suw_ \x1b[m" );
			}
		}
		UpdateToolbarUI();
	}
	else if( e.GetSocketEvent() == wxSOCKET_INPUT )	//pGq
	{
  		if( t->isBell() )	//ݬݸgL SCD_Telnet::parse() , S '\a' oӦr (]NOˬdSLHyi)
  		{
			if( ((SCD_Telnet*)tab.GetItemData(tab.GetSelection()))->getUserIdleTime() > 60 )	//pGϥΪ̶mWL@~۰ʤܨӰTsu
	  			tab.SetSelection(i);	//HyiӪ, h telnet e

			tab.SetItemImage( i, ICON_MESSAGE );	//קsuҪϥܴϥΪ̦y
//			wxBell();	
 			SCD_PlaySound();	//oXnϥΪ̦y

			if( t->getUserIdleTime() > 60*3 )	//pGӳsumL[
			{
				wxString msg;
				if( cfg.Read( GetUserConfigPath(_T("/setting/auto_reply")) , & msg ) )	//pG]w۰ʦ^Фy
				{
        			t->keyControl('R');
	 				t->UserSend( (char*) msg.c_str() );
	 				t->keyEnter();
	 				t->UserSend( "Y" );
	 				t->keyEnter();
				}
			}
  		}
	}
}
// ----------------------------------------------------------------------------
void BBS_Frame::OnChar(wxKeyEvent& event)
{
	int id = tab.GetSelection();
	if( tab.GetItemImage(id) == ICON_MESSAGE )
		tab.SetItemImage( id, ICON_CONNECTED );

#ifdef __WXGTK__
	if( event.AltDown() )
	{
		if( event.m_keyCode >= '1' && event.m_keyCode <= '9' )
			ShowSpecifiedTerminal( event.m_keyCode - '1' );
		else if( event.m_keyCode == '0' )
			ShowSpecifiedTerminal(-1);
//		else
//			event.Skip();	//קK scd_telnet BzoӦr
	}
//	else	event.Skip();
#else
	event.Skip();
#endif
}
// ----------------------------------------------------------------------------
void BBS_Frame::OnKeyDown(wxKeyEvent& event)
{	
	int id = tab.GetSelection();
	if( tab.GetItemImage(id) == ICON_MESSAGE )
		tab.SetItemImage( id, ICON_CONNECTED );

	//ۦBzֳt
	if( event.ControlDown() )
	{
		if( event.m_keyCode == WXK_LEFT )
			ShowPreviousTelnet();
		else if( event.m_keyCode == WXK_RIGHT )
			ShowNextTelnet();
		else if( event.m_keyCode == WXK_HOME )
			ShowSpecifiedTerminal(0);
		else if( event.m_keyCode == WXK_END )
			ShowSpecifiedTerminal( tab.GetItemCount() - 1 );
/*
		else if( event.m_keyCode == WXK_DELETE )
		{
			Command(MENU_DELETETELNET);
			//DeleteTerminal(-1);	//error
/ *
			wxCommandEvent e;
			e.SetId(MENU_DELETETELNET);
			this->AddPendingEvent(e);
* /
		}
*/
		else if( event.m_keyCode >= WXK_F1 && event.m_keyCode <= WXK_F12 )
			SendCanedMessage( event.m_keyCode - WXK_F1 + 1 );
	}
}
// ----------------------------------------------------------------------------
#include <wx/textdlg.h>
void BBS_Frame::OnConnection(wxCommandEvent& event)
{
	int id = event.GetId();
	switch(id)
	{
		case MENU_OPENSITELIST :
			{
				wxString _ip, _name;
				int _port;
				if( ShowSiteListDialog( _ip, _port, _name ) )
					connect( _ip , _port , _name );
				ReloadBookmark();
			}
			break;
		case MENU_QUICKCONNECT :
			{
				wxString site = wxGetTextFromUser( _T("пJD}\r\n\r\npGϥΫDw] port (23) nJAЦb}[W _: H port number\r\nҦpptt.twbbs.org:3456 NH port 3456 sW ptt.twbbs.org"), _T("ֳtsu") );
				if( ! site.IsEmpty() )	connect( site );
			}
			break;
		case MENU_CLOSECONNECTION :
			if(now_telnet)	now_telnet->close();
			break;
		case MENU_DELETETELNET :
			DeleteTerminal(-1);
			break;
		case MENU_RECONNECT :
			if(now_telnet == NULL)	return;
			if( now_telnet->IsDisconnected() )
			{
				tab.SetItemImage( tab.GetSelection(), ICON_CONNECTING );
				now_telnet->reconnect();
			}
			break;
		case MENU_GOPREV :
   			ShowPreviousTelnet();
			break;
		case MENU_GONEXT :
			ShowNextTelnet();
			break;
		case MENU_GOUSERSPECIFIEDTAB :
			ShowSpecifiedTerminal(-1);
			break;
		case MENU_FULLSCREEN :
			FullScreen();
			break;
		case MENU_LOGINWHENSTART :
			setLoginWhenStart( ! getLoginWhenStart() );
			break;
		case MENU_PASSWD :
			ShowPasswdDialog();
			ReloadBookmark();	//@wnsJ bookmark T, ]ªTٯdªKX
			break;
	}
}
// ----------------------------------------------------------------------------
void BBS_Frame::OnSetting(wxCommandEvent& event)
{
	int id = event.GetId();
	switch(id)
	{
		case MENU_FONT :
			UserSetFont(this);
			break;
		case MENU_LINK_PROGRAM :
			{
				wxArrayString list;
				list.Add( _T("http") );
				list.Add( _T("email") );
				list.Add( _T("ftp") );
				int id = wxGetSingleChoiceIndex( _T("пܭnsӶWsp{H") , _T("sWsp{") , list );
				if( id == -1 )	break;

    			enum LINK_TYPE _t;
				switch(id)
				{
					case 0 : _t = LINK_HTTP;	break;
					case 1 : _t = LINK_EMAIL;	break;
					case 2 : _t = LINK_FTP;		break;
					default : return;
				}

				wxString link_program = getLinkProgram(_t);
#if defined(__WXGTK__)
				link_program = wxGetTextFromUser( _T("аݭnέӵ{Ӷ}ҳoWsH") , _T("]wWsp{") , link_program );
#else
				link_program = wxFileSelector( _T("]wWsp{") , link_program, _T(""), _T("exe") , _T("{ (*.exe)|*.exe|Ҧɮ (*.*)|*.*") , wxOPEN | wxFILE_MUST_EXIST , this );
#endif
				if( ! link_program.IsEmpty() )	setLinkProgram( _t , link_program );
			}
			break;
		case MENU_AUTO_REPLY :
			{
			wxString msg;
   			cfg.Read( GetUserConfigPath(_T("/setting/auto_reply")) , & msg );
			msg = wxGetTextFromUser( _T("пJmɭn^Ǥr굹yAH\r\n\r\nU [Esc]  [Cancel]  [⤺eM] NNzQnoӾ\r\nQ]wЪ [OK] Yi\r\n( 䴩 BBMan 榡ưT )") , _T("۰ʤy^") , msg );
			if( ! msg.IsEmpty() )	cfg.Write( GetUserConfigPath(_T("/setting/auto_reply")) , msg );
			else if( cfg.Exists( GetUserConfigPath(_T("/setting/auto_reply")) ) )
			{
				if( wxYES == wxMessageBox( _T("n۰ʦ^ФyH") , _T("T{"), wxYES_NO ) )
					cfg.DeleteEntry( GetUserConfigPath(_T("/setting/auto_reply")) );
			}
			}
			break;
		case MENU_AUTO_RECONNECT :
      		wxMessageBox( _T("{wئ۰ʭssuC\r\nY BBS ]Ҧp KKCity^ bYǮɬq``|LksWAoɦ{|۰ʭssuAsWC") );
      		break;
		case MENU_PREVENT_DISCONNECT :
      		wxMessageBox( _T("{wبb (_u) C\r\n{|bmɨCT۰ʥX Ctrl+L  server se@e^ӡ]ӳoӫO|ùƦܤơ^AY϶m@Ѥ]|Q_uC") );
      		break;
		case MENU_EDIT_CANNED_MESSAGE :
			{
				wxArrayString msg_list;
				wxString key, msg;
				int id;
				cfg.SetPath( GetUserConfigPath(_T("/canned_msg/")) );
				for(id=1;id<=12;id++)
				{
					key = wxString::Format( _T("%d") , id );
					cfg.Read( key , & msg , wxEmptyString );
					msg = wxString::Format( _T("< ֳt Ctrl+F%d >G") , id ) + msg;
					msg_list.Add( msg );
				}
				
				id = wxGetSingleChoiceIndex( _T("пܭnsӧֳtTH\r\n\r\n( 䴩 BBMan 榡ưTCаѦҿ [] s BBMan 榡ưTk )") , _T("sֳtT") , msg_list );
				if( id == -1 )	break;
				id ++;

				key = wxString::Format( _T("%d") , id );
				cfg.Read( key , & msg , wxEmptyString );

				wxString new_msg;
				new_msg = wxGetTextFromUser( _T("sֳtT\r\n\r\n( Mũο [Cancel] NֳtT )") , _T("sֳtT") , msg );
				if( new_msg == msg )	break;
				else if( new_msg.IsEmpty() )
				{
					if( wxYES == wxMessageBox( _T("TwnR˰TH") , _T("R˰T") , wxYES_NO ) )
					{
						if( cfg.Exists(key) )	cfg.DeleteEntry(key);
					}
				}
				else
				{
					cfg.Write( key , new_msg );
				}
			}
			break;
		case MENU_MESSAGE_SOUND :
			{

#ifdef __WXGTK__
				wxString old_player, new_player;
				cfg.Read( GetUserConfigPath(_T("/setting/sound_player")) , & old_player , wxEmptyString );
				new_player = wxGetTextFromUser( _T("ЫwΨӼn{\n\nҦpGesdplay / artsplay / xmms") , _T("wΨӼn{") , old_player );
				if( new_player.IsEmpty() )
				{
					wxMessageBox( _T("zwn{") );
					break;
				}
				else cfg.Write( GetUserConfigPath(_T("/setting/sound_player")) , new_player );
#endif

				wxString old_file, new_file;
				cfg.Read( GetUserConfigPath(_T("/setting/sound_file")) , & old_file , wxEmptyString );
#ifdef __WXGTK__
				new_file = wxFileSelector( _T("}nɮ") , old_file.BeforeLast('/'), old_file.AfterLast('/'), _T("") , _T("") , wxOPEN | wxFILE_MUST_EXIST , this );
#else
				new_file = wxFileSelector( _T("}nɮס]ȱ .wav 榡^") , old_file.BeforeLast('\\'), old_file.AfterLast('\\'), _T("") , _T("nɮ (*.wav)|*.wav") , wxOPEN | wxFILE_MUST_EXIST , this );
#endif
				if( ! new_file.IsEmpty() )
				{
					cfg.Write( GetUserConfigPath(_T("/setting/sound_file")) , new_file );
					init_sound();
					SCD_PlaySound();
				}
				else if( ! old_file.IsEmpty() )
				{
					if( wxYES == wxMessageBox( _T("zFCO_QnnɮסAbyɡAHtιGnNH") , _T("T{"), wxYES_NO ) )
					{
						cfg.DeleteEntry( GetUserConfigPath(_T("/setting/sound_file")) );
						init_sound();
					}
				}
			}
			break;
		case MENU_LINE_WRAPED_LENGTH :
			{
				long len = wxGetNumberFromUser( _T("г]wKWrɨC̤jס]Ʀrݬɩ 5 ~ 100 ^\n\nYYrWXw׮ɵ{|۰_\n|۰ʰrM^A|ϤM^rQIb"), wxEmptyString,
							_T("KWɦ۰_"), SCD_Terminal::GetLineWrapedLength(), 5, 100, this );
				if(len > 0)	SetLineWrapedLength( len );
			}
			break;
		case MENU_NAWS :
			EnableNaws( ! isEnableNaws() );
			if( now_telnet )	now_telnet->OnResize();
			break;
		case MENU_MULTIBYTEWORDDETECTION :
			now_telnet->EnableMultibyteWordDecetion( ! now_telnet->isMultibyteWordDecetionEnabled() );
			break;
		case MENU_ALWAYS_HIGHLIGHT :
			{
				bool b = ! TerminalChar::getAlwaysHighlight();
				TerminalChar::setAlwaysHighlight(b);
				cfg.Write( GetUserConfigPath(_T("/setting/always_highlight")) , b );
				panel.Refresh();
			}
			break;
	}
}
// ----------------------------------------------------------------------------
/*
#if defined(__WXMSW__)
	#include <windows.h>
	#include <winreg.h>
#endif
*/
void BBS_Frame::OnTool(wxCommandEvent& event)
{
	int id = event.GetId();
	switch(id)
	{
	    case MENU_LOCKSCREEN :
			LockScreen();
			break;
		case MENU_EXPORT_SETTING :
			{
//#if defined(__WXMSW__)
/*
				HKEY reg_key;
				if( ! RegOpenKey( HKEY_CURRENT_USER , "\\Software\\BBMan", &reg_key ) == ERROR_SUCCESS )
    			{
					wxMessageBox( _T("ثe BBMan S󪺳]w") );
					return;
				}
				wxString path = wxFileSelector( _T("ץX BBMan ]w") , _T(""), _T("BBMan]w.reg"), _T("reg") , _T("Windows n|*.reg") , wxSAVE | wxOVERWRITE_PROMPT , this );
				if( path.empty() )	return;
				RegSaveKey( HKEY_CURRENT_USER , wxStringToCharPtr(path), NULL );
*/
/*
#elif defined(__WXGTK__)
				wxString path = wxFileSelector( _T("ץX BBMan ]w") , _T(""), _T("BBMan]w.txt"), _T("reg") , _T("Ҧɮ (*.*)|*.*") , wxSAVE | wxOVERWRITE_PROMPT , this );
				if( path.empty() )	return false;
				wxExecute( wxString( _T("cp ~/.BBMan ") ) + path );
#endif
*/
			}
			break;
	}
}
// ----------------------------------------------------------------------------
void BBS_Frame::SetTerminalFont(wxFont fnt)
{
	if(now_telnet)
	{
		now_telnet->OnResize();
		now_telnet->repaint(true);
	}
//	FitTerminalSize();
}
// ----------------------------------------------------------------------------
void BBS_Frame::FitTerminalSize()
{
/*
	now_telnet->repaint();
    wxSize size;
    if(now_telnet)	size = now_telnet->getWindowSize();
    else size = panel.GetClientSize();
    size.SetHeight( size.GetHeight() + tab.GetSize().GetHeight() );
	SetClientSize(size);
*/
}
// ----------------------------------------------------------------------------
void BBS_Frame::recalcVarFontSize()	//sp panel i̤jrjp
{
/*
#if defined(__WXGTK__)	//] GTK UܴrMjp| crash ҥHȮɨ\
	var_fnt_size = GetCurrentFont().GetPointSize();
	return;
#endif
*/

	wxSize new_winsize = panel.GetClientSize();

	wxFont fnt = GetCurrentFont();
	wxClientDC dc(this);
	int cw, ch;

	int delta_pt;
	if( var_fnt_size < 9 )	var_fnt_size = 9;
	else if( var_fnt_size > 25 )	var_fnt_size = 25;
	fnt.SetPointSize( var_fnt_size );
	dc.SetFont(fnt);

	cw = dc.GetCharWidth();
	ch = dc.GetCharHeight();

	if( cw*80 > new_winsize.GetWidth() || ch*24 > new_winsize.GetHeight() )
		delta_pt = -1;
	else	delta_pt = 1;

	while(true)
	{
		if( var_fnt_size < 9 ) 	break;
		else if( var_fnt_size > 25 ) break;

		var_fnt_size += delta_pt;
		fnt.SetPointSize( var_fnt_size );

		dc.SetFont(fnt);

		cw = dc.GetCharWidth();
		ch = dc.GetCharHeight();

		if( delta_pt == 1 )
		{
			if( cw*80 > new_winsize.GetWidth() || ch*24 > new_winsize.GetHeight() )
			{
				var_fnt_size --;
				break;
			}
		}
		else
		{
			if( cw*80 < new_winsize.GetWidth() && ch*24 < new_winsize.GetHeight() )
				break;
		}
	}

}


void BBS_Frame::OnResize(wxSizeEvent& event)
{
	tab.Move(0,0);
	tab.SetSize( GetClientSize().GetWidth(), tab.GetSize().GetHeight() );
	panel.Move(0, tab.GetSize().GetHeight());
	panel.SetSize( GetClientSize().GetWidth() , GetClientSize().GetHeight() - tab.GetSize().GetHeight() );

	int t = var_fnt_size;
	recalcVarFontSize();

	if(now_telnet && t != var_fnt_size )
	{
		now_telnet->OnResize();
		now_telnet->repaint(true);
	}
}
// ----------------------------------------------------------------------------
void BBS_Frame::OnGoTab(wxCommandEvent& event)
{
	int id = event.GetId();
	id = id - MENU_GOTAB_1;
	if( tab.GetSelection() != id )	tab.SetSelection( id );
}
// ----------------------------------------------------------------------------
void BBS_Frame::SendCanedMessage(int id)
{
	if( ! now_telnet )	return;
	if( id < 1 || id > 12 )	return;

	wxString key = wxString::Format( _T("/canned_msg/%d") , id );
	wxString msg;

	if(  cfg.Read( key , & msg ) && ( ! msg.IsEmpty() )  )
		now_telnet->UserSend_spacial(msg);
}
// ----------------------------------------------------------------------------
void BBS_Frame::OnCanedMessage(wxCommandEvent& event)
{
	if( ! now_telnet )	return;

	int id = event.GetId();
	id = id - MENU_CANNED_MESSAGE_1 + 1;
	SendCanedMessage(id);
}
// ----------------------------------------------------------------------------
void BBS_Frame::DeleteTerminal(int id)
{
	if( id == -1 )	id = tab.GetSelection();
	if( id < 0 || id >= tab.GetItemCount() )	return;

	int img = tab.GetItemImage(id);

	if( img == ICON_CONNECTED || img == ICON_MESSAGE )
		if( wxNO == wxMessageBox( wxString::Format( _T("O_nsu [ %d. %s ]") , id+1 , wxStringToCharPtr(tab.GetItemText(id)) ) , _T("su"), wxYES_NO ) )
			return;

	SCD_Telnet *t;
	t = (SCD_Telnet*) tab.GetItemData(id);
	tab.DeleteItem(id);
	delete t;
}
// ----------------------------------------------------------------------------
void BBS_Frame::ShowSpecifiedTerminal(int id)
{	//id==-1 NnX{ܮϥΪ̿

	if( id == -1 )
	{
		int c = tab.GetItemCount();
		if(c <= 1)	return;

		wxString line = wxGetTextFromUser( wxString::Format( _T("пJsusG%d  %d") , 1 , c) , _T("wsu") , wxEmptyString , this);
		if( line.IsEmpty() )	return;
		else if( ! line.IsNumber() )
		{
			wxMessageBox( _T("zJOƦr") );
			return;
		}
		else
		{
			line.ToLong( (long*) &id );
			if( id < 1 || id > tab.GetItemCount() )
			{
				wxMessageBox( _T("ҿJƦrWXd") );
				return;
			}
			else	id = id - 1;
		}
	}

	if( id != tab.GetSelection() )	tab.SetSelection(id);
}
// ----------------------------------------------------------------------------
void BBS_Frame::FullScreen()
{
	blFullScreen = ! blFullScreen;
	//Фn wxFULLSCREEN_NOBORDER oӳ]wȨ :)
	ShowFullScreen( blFullScreen , wxFULLSCREEN_NOBORDER | wxFULLSCREEN_NOCAPTION );
}
// ----------------------------------------------------------------------------
void BBS_Frame::OnUpdate_UI(wxUpdateUIEvent& event)
{
	int id = event.GetId();
	switch(id)
	{
		case MENU_NAWS :
			event.Check( isEnableNaws() );
			break;
		case MENU_MULTIBYTEWORDDETECTION :
			event.Check( now_telnet && now_telnet->isMultibyteWordDecetionEnabled() );
			break;
		case MENU_ALWAYS_HIGHLIGHT :
			event.Check( TerminalChar::getAlwaysHighlight() );
			break;
		case MENU_LOGINWHENSTART :
			event.Check( getLoginWhenStart() );
			break;
		case MENU_FULLSCREEN :
			event.Check( blFullScreen );
			break;
	}
}
// ----------------------------------------------------------------------------
void BBS_Frame::UpdateToolbarUI()
{
    bool b, nb, c;
    if( now_telnet )
    {
        c = true;
        nb = now_telnet->IsDisconnected();
        b = ! nb;
        tb->EnableTool( MENU_MULTIBYTEWORDDETECTION , now_telnet->isMultibyteWordDecetionEnabled() );
    }
    else
    {
        c = b = nb = false;
        tb->EnableTool( MENU_MULTIBYTEWORDDETECTION , false );
    }

    tb->EnableTool( MENU_CLOSECONNECTION , b );
    tb->EnableTool( MENU_RECONNECT , nb );
    tb->EnableTool( MENU_DELETETELNET , c );
    tb->EnableTool( MENU_ADDBOOKMARK , b );
    tb->EnableTool( MENU_COPY , b );
    tb->EnableTool( MENU_COPY_ANSI , b );
    tb->EnableTool( MENU_PASTE_ANSI , b );
    tb->EnableTool( MENU_MULTIBYTEWORDDETECTION , b );
    tb->EnableTool( MENU_COPY , b );
}

// ============================================================================
#endif
