/******************************************************************************
 * {]p̡GFjt@²EF@2004/02
 *
 * nĥ GPL vAҦ{XҥiۥѴGέק
 * Ҧ{]p̤TФHOd :)
 ******************************************************************************/


#ifndef MISC_CPP
#define MISC_CPP

inline wxString GetLoginPassword();
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

wxString CharPtrTowxString(const char *str)
{
	static wxMBConvUTF8 mb;
	return wxString( mb.cMB2WC(str) );
}

char* wxStringToCharPtr(const wxString &str)
{
	static wxMBConvUTF8 mb;
	return (char*) mb.cWX2MB( str.c_str() );
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

inline int h2n(char h)
{
	if(h>='0'&&h<='9')	return h-'0';
	h = tolower(h);
	if(h>='a'&&h<='f')	return h-'a'+10;
	return -1;	//error
}

inline char n2h(int n)
{
	if(n>=0&&n<=9)	return '0'+n;
	if(n>=10&&n<=15)	return 'a'+n-10;
	return '?';	//error
}

inline void h2c(char *s)
{
	char *r,*w;
	for(r=s, w=s ; r[0]!='\0' && r[1]!='\0' ; w++ , r++, r++)
	{
		*w = h2n(r[0]) << 4 | h2n(r[1]);
	}
	*w = '\0';
}

inline void c2h(char *s)
{
	int len = strlen(s);
	int r,w;
	s[len+len] = '\0';
 	for(r=len-1 , w=len+len-2 ; r>=0 ; r-- , w--, w--)
	{
		int a, h,l;
		a = s[r];
  		h = (a & 0xf0) >> 4;
		l = a & 0x0f;
		s[w] = n2h(h);
		s[w+1] = n2h(l);
	}
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#include "des.cpp"
wxString SCD_des_decrypt(wxString _password , wxString _encoded_data)
{
	char buf[1000];
	strcpy( buf , wxStringToCharPtr(_encoded_data) );
	h2c(buf);
	SCD_des_decrypt( wxStringToCharPtr(_password) , buf );
	return buf;
}

wxString SCD_des_encrypt(wxString _password , wxString _decoded_data)
{
	char buf[1000];
	strcpy( buf , wxStringToCharPtr(_decoded_data) );
	SCD_des_encrypt( wxStringToCharPtr(_password) , buf );
	c2h(buf);
	return buf;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

typedef struct
{

	// "name:ip:port:autoopen:username:password
public:
	wxString name, ip;
	int port;
	bool autoopen;	//Ұʵ{ɦ۰ʶ}
	wxString username;	//۰ʵnJ
	wxString message;	//su (Φ۰ʵnJ) ۰ʰeX BBMan 榡ưT
	wxString password;

public:
	void Set(wxString str)
	{
		name = _T("");
		ip = _T("");
		port = 23;
		autoopen = false;
		username = _T("");
		password = _T("");

  		wxString tmp;

		name = str.BeforeFirst(':');	str = str.AfterFirst(':');
		ip = str.BeforeFirst(':');	str = str.AfterFirst(':');
		tmp = str.BeforeFirst(':');	str = str.AfterFirst(':');
		tmp.ToLong( (long*) & port );
		tmp = str.BeforeFirst(':');	str = str.AfterFirst(':');
		if(tmp == _T("y") )	autoopen = true;
		username = str.BeforeFirst(':');	str = str.AfterFirst(':');
		password = str.BeforeFirst(':');	str = str.AfterFirst(':');
		message = str.BeforeFirst(':');

		//NKX DES ѱK
		if( ! password.IsEmpty() )	password = SCD_des_decrypt( GetLoginPassword() , password );
		if( ! message.IsEmpty() ) message = SCD_des_decrypt( GetLoginPassword() , message );
	}
	wxString Get()
	{

		wxString tmp_pass = _T("");
		wxString tmp_message = _T("");

		// DES [K
		if( ! password.IsEmpty() ) tmp_pass = SCD_des_encrypt( GetLoginPassword() , password );
		if( ! message.IsEmpty() ) tmp_message = SCD_des_encrypt( GetLoginPassword() , message );

		return name + _T(":") + ip + _T(":") + wxString::Format( _T("%d") , port )
			+ _T(":") + (autoopen? _T("y") : _T("n") ) + _T(":") + username + _T(":") + tmp_pass + _T(":") + tmp_message + _T(":::::");
	}
	wxString GetPassword()
	{	return password;	}
	void SetPassword(wxString pass)
	{	password = pass;	}

	bool isAutoOpen()	{	return autoopen;	}
	bool isAutoLogin()	{	return ! username.IsEmpty();	}

} SiteInfo;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

wxString Login_ID("");		//ϥΪ̥ثe
wxString Login_Password;	//ϥΪ̱KX
char *Default_Password = "eU6cZpQw";

inline bool isAnonymousLogin()
{	return Login_ID.IsEmpty();	}

inline wxString GetLoginPassword()
{
	if( isAnonymousLogin() )	return Default_Password;
	else return Login_Password;
}
inline wxString GetLoginName()
{	return Login_ID;	}

inline wxString GetUserConfigPath(wxString _path)
{
	if( isAnonymousLogin() )	return _path;
	else return _T("/usr/") + Login_ID + _path;
}

bool auth(wxString _user , wxString _pass)	//ҨϥΪ̱bKX
{
	wxString real_pass;
	if( _user.IsEmpty() || _pass.IsEmpty() )	return false;
	if( ! cfg.Read( _T("/usr/") + _user + _T("/password") , & real_pass ) )	return false;
	if( SCD_des_decrypt( _pass , real_pass ).CompareTo(Default_Password) != 0 )	return false;
	return true;
}

void passwd(wxString _user , wxString _pass)	//קKX
{
	cfg.Write( _T("/usr/") + _user + _T("/password") , SCD_des_encrypt( _pass , Default_Password ) );
}

void setLoginWhenStart(bool b)
{
	cfg.Write( _T("/setting/login_when_start") , b );
}
bool getLoginWhenStart()
{
	bool b;
	cfg.Read( _T("/setting/login_when_start") , & b , true );
	return b;
}

bool isUserExist(wxString _user)
{	return cfg.Exists( _T("/usr/") + _user );	}

void ShowNewAccountDialog()	//sWb
{
	wxString user, pass, tmp_pass;
 	while(true)
	{
		user = wxGetTextFromUser( _T("sWbW١] Esc ^") , _T("sWb") );
		user.Trim();
		if( user.IsEmpty() )	return;
		if( isUserExist(user) )
		{
			wxMessageBox( _T("bwgHϥΤF"), _T("ϥΪ̱bwsb") );
			continue;
		}
		pass = wxGetPasswordFromUser( _T("пJKX]ֻ̤ݤTӦr^") , _T("JKX") );
		pass.Trim();
		if( pass.IsEmpty() || pass.Len() < 3 )
		{	wxMessageBox( _T("KXץjTӦr") , _T("KX~") );	continue;	}
		tmp_pass = wxGetPasswordFromUser( _T("ЦAJKXT{") , _T("T{KX") );
		tmp_pass.Trim();
		if( tmp_pass != pass )
		{	wxMessageBox( _T("⦸JKXP") , _T("KXT{~") );	continue;	}

 		//إ߷sb
		passwd( user, pass );
		wxMessageBox( _T("sWb") , _T("sWb") );
		//
		break;
	}
}

void ShowPasswdDialog()	//קKX
{
	if( isAnonymousLogin() )
	{	wxMessageBox( _T("z{bOΦWnJAקKX") , _T("") );	return;	}

	wxString old_pass, new_pass, tmp_pass;
	while(true)
	{
		old_pass = wxGetPasswordFromUser( _T("пJ±KX] Esc ^") ,	_T("קnJKX Step 1") );
		old_pass.Trim();	if( old_pass.IsEmpty() ) 	return;
		if( old_pass != GetLoginPassword() )	wxMessageBox( _T("±KXJ~") , _T("") );
		else break;
	}
 	while(true)
	{
		new_pass = wxGetPasswordFromUser( _T("пJsKX]ֻ̤ݤTӦr^] Esc ^") ,	_T("קnJKX Step 2") );
		if( new_pass.IsEmpty() )	return;
		new_pass.Trim();
		if( new_pass.Len() < 3 )  	{	wxMessageBox( _T("KXֻ̤ݤTӦrAЭsJ") );	continue;	}
		tmp_pass = wxGetPasswordFromUser( _T("ЦA@JsKXT{") ,	_T("קnJKX Step 3") );
		tmp_pass.Trim();
		if( new_pass != tmp_pass )  	{	wxMessageBox( _T("⦸ҿJsKXۦPAЭsJ") );	continue;	}
		else break;
	}

	//קKX
	passwd( GetLoginName() , new_pass );
	//קҦ bookmark KX
	SiteInfo si;
 	cfg.SetPath( GetUserConfigPath(_T("/bookmark/")) );
	wxString name, str;
	long id;
	bool ret;
	ret = cfg.GetFirstEntry( name , id );
	while( ret )
	{
		if( cfg.Read( name , &str ) )
		{
			Login_Password = old_pass;
			si.Set(str);
			Login_Password = new_pass;
			cfg.Write( name , si.Get() );
		}
		ret = cfg.GetNextEntry( name , id );
	}
	//
	Login_Password = new_pass;
	wxMessageBox( _T("KXק粒") , _T("קKX") );
}

void ShowLoginDialog()	//nJ
{
	wxString user, pass;
	while(true)
	{
		user = wxGetTextFromUser( _T("пJnJb\n\n Esc NΦWnJ\n\nJ new NsWb\n\nYƱC}ҵ{X{Aisu [su] -> [nJ]w] ") ,
				_T("nJ BBMan") );
  		user.Trim();
		if( user.IsEmpty() )	break;
		if( user == _T("new") )
		{	ShowNewAccountDialog();	continue;	}
		pass = wxGetPasswordFromUser( _T("пJnJKX") , _T("JKX") );
		pass.Trim();
		if( auth(user, pass) )
		{
			Login_ID = user;
			Login_Password = pass;
			break;
		}
		else
			wxMessageBox( _T("bαKXJ~AЭsJ") , _T("nJ") );
	}
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#include <wx/clipbrd.h>
void CopyToClipboard(wxString text , bool comm_with_other = false)
{
	if (wxTheClipboard->Open())
    {
        wxTheClipboard->SetData( new wxTextDataObject(text) );
        wxTheClipboard->Close();
    }

/*
    if (wxTheClipboard->Open())
    {
//      wxTheClipboard->SetData( new wxTextDataObject( CharPtrTowxString(Big5ToUnicode(wxStringToCharPtr(text))) ) );
//      wxTheClipboard->SetData( new wxTextDataObject( text ) );
        wxTheClipboard->SetData( new wxTextDataObject(text) );
        wxTheClipboard->Close();
    }
    wxTheClipboard->Clear();
    static wxTextCtrl textctrl;
    wxString txt = GetSelectionContent(withANSI);
wxMessageBox(txt);
    textctrl.SetValue( txt );
    textctrl.SetSelection( 0, -1 );
    textctrl.Copy();
    textctrl.SetValue( wxEmptyString );
*/

#ifdef __WXGTK__
	/*if(comm_with_other)*/	ShowCopyDialog( text );
#endif

}

// ----------------------------------------------------------------------------

wxString GetTextFromClipboard( bool comm_with_other = false )
{
	wxString text;

    if (wxTheClipboard->Open())
    {
		if( wxTheClipboard->IsSupported( wxDF_TEXT ) )
        {
            wxTextDataObject data;
            wxTheClipboard->GetData( data );
            text = data.GetText();
        }
        wxTheClipboard->Close();
    }

//	text = UTF8_To_Big5( wxStringToCharPtr(text) );

#ifdef __WXGTK__
	/*if(comm_with_other && text.IsEmpty() )*/	//text = ShowPasteDialog();
#endif

//	text = UTF8_To_Big5( wxStringToCharPtr(text) );

	return text;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
#endif
