/******************************************************************************
 * {]p̡GFjt@²EF@2004/02
 *
 * nĥ GPL vAҦ{XҥiۥѴGέק
 * Ҧ{]p̤TФHOd :)
 ******************************************************************************/


#ifndef SCD_TELNET_CPP
#define SCD_TELNET_CPP

#include "scd_terminal.cpp"

#include <wx/socket.h>
#include <wx/clipbrd.h>
#include <wx/timer.h>	//wxGetLocalTime()
#include <ctype.h>		//tolower()

/*
#include <winsock2.h>
#include "libssh/scd_ssh.cpp"
*/

// ============================================================================

//F SCD_Telnet ౵ SocketEvent , ҥH~ wxEvtHandler
class SCD_Telnet : public SCD_Terminal , protected wxEvtHandler
{
private:
	wxString ip, name;
	int port;

	wxString username , password , message;	//۰ʵnJ
	bool need_to_autologin;
	bool user_closed;	//ϥΪsuHserver _uH

	bool negotiation();

	//abstract
//	SCD_SSH sock;
	wxSocketClient sock;
	bool SocketConnect(wxIPV4address& address, bool wait);
	int local_buf_len;
 	int SocketRead(void *buf, int len);	//oOFѨM Socket::Unread Dӳ]
	inline void SocketUnread(void *buf, int len);	//oOFѨM Socket::Unread Dӳ]
	inline void SocketWrite(void *buf, int len);
	void InitSocket();
	void CloseSocket();
	void DestroySocket();
	bool SocketIsConnected();
	void *SocketGetClientData();
 	//

public:
	SCD_Telnet(wxWindow *win);
	~SCD_Telnet();

	wxString getIP()	{	return ip;		}
	int getPort()		{	return port;	}
	wxString getName()	{	return name;		}

	bool connect(wxString _ip , int _port , wxString _name , wxString _user , wxString _passwd , wxString _message );
	bool reconnect();
	void close();
	inline bool isUserClosed()	{	return user_closed;	}

	void UserSend(char *buf, int len);
	void UserSend(wxString buf);
	void UserSend_spacial(wxString msg);	//eX榡Ʀr

	void keyEnter();
	void keyUp();
	void keyDown();
	void keyLeft();
	void keyRight();
	void keyControl(char ch);

	void Paste(char *txt, bool withANSI);
 	void PasteFromClipboard(bool withANSI);	//qŶKïWŪr, åBǰe server





	bool blSupportNAWS;	// server O_䴩ù
	void OnServerSupportNAWS()	//bo server 䴩ù
	{	blSupportNAWS = true;	/*wxMessageBox( name );*/	OnResize();	}
	void OnLogined()	//bϥΪ̭nJ
	{	if( ! blSupportNAWS )	setColumnRow(80,24);	}
	bool SetNAWS(int _c, int _r)	// telnet suC
	{
		if( ! blSupportNAWS )	return false;

  		int col_count , row_count;
		getColumnRowCount( &col_count , &row_count );
		if( _c == col_count && _r == row_count )	return true;

		unsigned char buf[10];
		buf[0] = '\xff';	buf[1] = '\xfa';	buf[2] = '\x1f';
		buf[3] = '\x00';	buf[4] = (char)_c;	buf[5] = '\x00';
		buf[6] = (char)_r;	buf[7] = '\xff';	buf[8] = '\xf0';

		UserSend( (char*)buf, 9);

		setColumnRow( _c , _r );
		repaint(true);

		return true;
	}

	void Show()
	{
		OnResize();
		SCD_Terminal::Show();
	}
	void OnResize()
	{
		wxFont fnt = GetCurrentFont();

		if( blSupportNAWS && isEnableNaws() )
		{
			SetFont( fnt );

			wxSize cs = getCharSize();
			wxSize new_winsize = getParentWindow()->GetClientSize();
			int nc = new_winsize.GetWidth() / cs.GetWidth();
			int nr = new_winsize.GetHeight() / cs.GetHeight();
			if( nc < 80 )	nc = 80;
			if( nr < 24 )	nr = 24;

			SetNAWS(nc, nr);
		}
		else
		{
			fnt.SetPointSize( var_fnt_size );
			SetFont(fnt);

			SetNAWS(80, 24);
		}
	}





private:
	unsigned char connect_state;	//0(close) 1(connecting) 2(connected)
public:
	bool IsDisconnected()	{	return connect_state == 0;	}
	bool IsConnecting()		{	return connect_state == 1;	}
	bool IsConnected()		{	return connect_state == 2;	}



	//**************** Osuɶ ****************//

private:	long start_time;
public:
	int getConnectTime()	{	return wxGetLocalTime() - start_time;	}

	//**************** b ****************//

private:
	long server_idle_time;
	long user_idle_time;	//ϥΪ̳̫ OnKeyEvent ɶ
	void UnIdleServer();	//ѰmL[A
	void UnIdleUser();		//ѰmL[A
public:
	int getServerIdleTime();	//omɶ
	int getUserIdleTime();	//omɶ


	//**************** ƥ ****************//

	void OnSocketEvent( wxSocketEvent &e );

	void OnKeyDown(wxKeyEvent& event);
	void OnChar(wxKeyEvent& event);

private:
	bool blMultibyteWordDecetionEnabled;
public:
	inline void EnableMultibyteWordDecetion(bool b)
	{	blMultibyteWordDecetionEnabled = b;	}
	inline bool isMultibyteWordDecetionEnabled()
	{	return blMultibyteWordDecetionEnabled;	}

private:
    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(SCD_Telnet, SCD_Telnet)
	EVT_SOCKET(666 , SCD_Telnet::OnSocketEvent)
END_EVENT_TABLE()

// ============================================================================

SCD_Telnet::SCD_Telnet(wxWindow *win) : SCD_Terminal(win)
{
	local_buf_len = 0;
	connect_state = 0;
	blMultibyteWordDecetionEnabled = true;
	InitSocket();
}
// ----------------------------------------------------------------------------
SCD_Telnet::~SCD_Telnet()
{
	close();

	//iH delete sock
 	//] sock.Destroy iH sock b destroy S socket event
	DestroySocket();
}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
void SCD_Telnet::InitSocket()
{
	sock.SetTimeout(0);
	sock.SetFlags(wxSOCKET_NOWAIT);
	sock.SetClientData(this);

	sock.SetNotify( wxSOCKET_INPUT_FLAG | wxSOCKET_CONNECTION_FLAG | wxSOCKET_LOST_FLAG );
	sock.SetEventHandler(*this, 666);
}
// ----------------------------------------------------------------------------
bool SCD_Telnet::SocketConnect(wxIPV4address& address, bool wait = TRUE)
{
	sock.Notify(true);
	return sock.Connect(address, wait);
}
// ----------------------------------------------------------------------------
void SCD_Telnet::CloseSocket()
{
	sock.Close();
	sock.Notify(false);
}
// ----------------------------------------------------------------------------
inline void SCD_Telnet::DestroySocket()
{
	//iH delete sock
 	//] sock.Destroy iH sock b destroy S socket event
	sock.Destroy();
}
// ----------------------------------------------------------------------------
bool SCD_Telnet::SocketIsConnected()
{	return sock.IsConnected();	}
// ----------------------------------------------------------------------------
void* SCD_Telnet::SocketGetClientData()
{	return sock.GetClientData();	}
// ----------------------------------------------------------------------------
int SCD_Telnet::SocketRead(void *buf, int len)
{
	int c = 0;	//JFhָƶiJ buf F ?

	if( local_buf_len >= len )
	{
		sock.Read( buf, len );
		local_buf_len -= len;
		c = len;
	}
	else
 	{
 		sock.Read( buf, local_buf_len );
 		len -= local_buf_len;
 		sock.Read( (char*)buf + local_buf_len , len );
  		c = local_buf_len + sock.LastCount();
  		local_buf_len = 0;
	}

	return c;
}
// ----------------------------------------------------------------------------
void SCD_Telnet::SocketUnread(void *buf, int len)
{
	sock.Unread( buf, len );
	local_buf_len += len;
}
// ----------------------------------------------------------------------------
void SCD_Telnet::SocketWrite(void *buf, int len)
{
	sock.Write(buf, len);
	UnIdleServer();
}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
int SCD_Telnet::getServerIdleTime()	//omɶ
{
	if( ! IsConnected() )	return -1;
	return wxGetLocalTime() - server_idle_time;
}
// ----------------------------------------------------------------------------
int SCD_Telnet::getUserIdleTime()	//omɶ
{
	if( ! IsConnected() )	return -1;
	return wxGetLocalTime() - user_idle_time;
}
// ----------------------------------------------------------------------------
void SCD_Telnet::UnIdleServer()	//ѰmL[A
{
	server_idle_time = wxGetLocalTime();	//}lmɶ
}
// ----------------------------------------------------------------------------
void SCD_Telnet::UnIdleUser()	//ѰmL[A
{
	user_idle_time = wxGetLocalTime();	//}lmɶ
}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
void SCD_Telnet::UserSend(char *buf, int len = -1)
{
	if( len < 0 )	len = strlen( (char*)buf);
	SocketWrite( buf, len );
}
// ----------------------------------------------------------------------------
void SCD_Telnet::UserSend(wxString buf)
{
    UserSend( wxStringToCharPtr(buf) );
}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
void SCD_Telnet::UserSend_spacial(wxString msg)	//eX榡Ʀr
{
	/*
		\n		enter
		\^R		ctrl+R
		\#{u,d,l,r}		WUk
		\p1		pause
		\\		\
	*/

	wxString ret;
	ret.Empty();

	while(true)
	{
		ret += msg.BeforeFirst('\\');
		msg = msg.AfterFirst('\\');

		if( msg.IsEmpty() )  break;
		else //pGr
		{
	  		wxChar ch = msg.GetChar(0);
	  		switch(ch)
	  		{
         		case '#':
					{
                   		char b = (char) msg.GetChar(1);
						b = tolower(b);
                   		if( b == 'u' )
                   		{
							UserSend(ret);	ret.Empty();
							keyUp();
	    	           		msg = msg.Right( msg.Length() - 2 );
						}
                   		else if( b == 'd' )
                   		{
							UserSend(ret);	ret.Empty();
							keyDown();
	    	           		msg = msg.Right( msg.Length() - 2 );
						}
                   		else if( b == 'l' )
                   		{
							UserSend(ret);	ret.Empty();
							keyLeft();
	    	           		msg = msg.Right( msg.Length() - 2 );
						}
                   		else if( b == 'r' )
                   		{
							UserSend(ret);	ret.Empty();
							keyRight();
	    	           		msg = msg.Right( msg.Length() - 2 );
						}
						else
						{
          					ret += _T("\\");
						}
					}
               		break;
         		case 'n':
					UserSend(ret);	ret.Empty();
					keyEnter();
               		msg = msg.Right( msg.Length() - 1 );
               		break;
         		case '^':
					{
                   		char b = (char) msg.GetChar(1);
						b = tolower(b);
                   		if( b >= 'a' && b <= 'z' )
                   		{
							UserSend(ret);	ret.Empty();
							keyControl( b );
	    	           		msg = msg.Right( msg.Length() - 2 );
						}
						else
						{
		               		ret += _T("\\^");
        		       		msg = msg.Right( msg.Length() - 1 );
						}
					}
               		break;
         		case '\\':
               		ret += _T("\\");
               		msg = msg.Right( msg.Length() - 1 );
               		break;
         		case 'p':
               		{
                     	wxChar sleep_sec_ch = msg.GetChar(1);
                     	int sleep_sec = 0;
                     	if( sleep_sec_ch >= '0' && sleep_sec_ch <= '9' )
                     	{
                     		sleep_sec = sleep_sec_ch - '0';
		               		msg = msg.Right( msg.Length() - 2 );
						}
						else
						{
		               		msg = msg.Right( msg.Length() - 1 );
		               		ret += _T("\\p");
          					break;
						}

                     	UserSend(ret);	ret.Empty();

      					long et = wxGetLocalTime();
						while(true)
						{
          					if( wxGetLocalTime() - et >= sleep_sec )	break;
							if(app->Pending())	app->Dispatch();
							app->Yield();
						}
					}
               		break;
			}
		}
	}

	UserSend(ret);
}
// ----------------------------------------------------------------------------
void SCD_Telnet::keyEnter()
{
    char ch = (char)13;
    UserSend( &ch, 1);
}
// ----------------------------------------------------------------------------
void SCD_Telnet::keyUp()
{	UserSend("\x1b\x5b\x41");	}
// ----------------------------------------------------------------------------
void SCD_Telnet::keyDown()
{	UserSend("\x1b\x5b\x42");	}
// ----------------------------------------------------------------------------
void SCD_Telnet::keyLeft()
{	UserSend("\x1b\x5b\x44");	}
// ----------------------------------------------------------------------------
void SCD_Telnet::keyRight()
{	UserSend("\x1b\x5b\x43");	}
// ----------------------------------------------------------------------------
void SCD_Telnet::keyControl(char ch)
{
	ch = tolower(ch);
	if( ch >= 'a' && ch <= 'z' )
	{
	    ch = ch - 0x60;
    	UserSend( &ch , 1 );
	}
}
// ----------------------------------------------------------------------------
void SCD_Telnet::Paste(char *txt, bool withANSI)
{
	char *w = txt;

	if( withANSI )	//pGnƻsm ANSI code
	{
		while( *w != '\0' )
		{
			if( *w == '\x1b' )	*w = '\x15';
			w++;
		}
	}
	else
	{
		char *r = txt;
		while( *r != '\0' )
		{
			if( *r == '\x1b' && r[1] == '[' )	//X}Y
			{
				r++;
				while(1)
				{
					r++;
					if( isalpha(*r) )	{	r++;	break;	}
					else if( *r == '\0' )	break;
				}
			}
			else
			{
				*w = *r;
				w++;	r++;
			}
		}
		*w = '\0';
	}

	UserSend( GetLineWrapedString(txt) );
}
// ----------------------------------------------------------------------------
void SCD_Telnet::PasteFromClipboard(bool withANSI)	//qŶKïWŪr, åBǰe server
{
	if( ! IsConnected() )	return;

	wxString text = GetTextFromClipboard();
	if( text.IsEmpty() )	return;

	Paste( wxStringToCharPtr(text) , withANSI );
}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
void SCD_Telnet::OnChar(wxKeyEvent& event)
{
	UnIdleUser();

	if( event.AltDown() )	event.Skip();
	else
	{
		int key = event.GetKeyCode();
//wxMessageBox( wxString::Format("OnChar : %%%02x -> %c", (unsigned int)key, (char)key) );
		UserSend( (char*)&key, 1 );
	}
}
// ----------------------------------------------------------------------------
void SCD_Telnet::OnKeyDown(wxKeyEvent& event)
{
	if( ! IsConnected() ) return;	//pGSsu, NnǸ
	UnIdleUser();

	int key = event.GetKeyCode();
	char *output = NULL;
	char num_buf[] = "s";	// [Lk䪺Ʀr] Odwİ
	if( key == WXK_DELETE )
	{
		if( isMultibyteWordDecetionEnabled() && isCurrentAWord() )	output = "\x1b[3~\x1b[3~";
		else	output = "\x1b[3~";
	}
	else if( key == WXK_BACK )	//back space
	{
		if( isMultibyteWordDecetionEnabled() && isLeftAWord() )	output = "\x7f\x7f";
		else	output = "\x7f";
	}
	else if( isascii(key) )
	{
#if defined(__WXGTK__)
		if( event.ControlDown() )
		{
			if( ! isalpha(key) )	return;
			key = tolower(key) - 0x60;
		}
		if( ! event.ShiftDown() )	key = tolower(key);
		UserSend( (char*)&key, 1 );
#else
		event.Skip();	//浹 OnChar event Bz
#endif
//wxMessageBox(wxString::Format("%d", key) );
	}
	else
	{
		if( key >= 326 && key <= 335 )	//pGOLk䪺Ʀr
		{
			num_buf[0] = (char)(key - 326) + '0';
			output = num_buf;
		}
		else
		{
			if( ! event.ControlDown() && ! event.AltDown() )
			switch(key)
			{
/*
				case WXK_TAB :	output = "";	break;
				case WXK_ESCAPE :	output = "";	break;
*/

				case WXK_HOME :		output = "\x1b[1~";/*"\x1b\x5b\x37~";*/	break;
				case WXK_END :		output = "\x1b[4~";/*"\x1b\x5b\x38~";*/	break;
				case WXK_INSERT :	output = "\x1b\x5b\x32~";	break;
				case 395 :			output = ".";					break;	//Lk, Ʀr [pI] 

				case WXK_UP :		keyUp();		break;
				case WXK_DOWN :		keyDown();		break;
				case WXK_LEFT :
        			keyLeft();
					if( isMultibyteWordDecetionEnabled() && isLeftAWord() )	keyLeft();
        			break;
				case WXK_RIGHT :
        			keyRight();
					if( isMultibyteWordDecetionEnabled() && isCurrentAWord() )	keyRight();
        			break;

				case 312 :			output = "\x1b\x5b\x35~";	break;	//page up
				case 313 :			output = "\x1b\x5b\x36~";	break;	//page down

				default :
//wxMessageBox(wxString::Format("%d", key) );
					event.Skip();	//浹 OnChar event Bz
					break;
			}
		}
	}

	if( output != NULL )	UserSend( output );
}
// ----------------------------------------------------------------------------

void SCD_Telnet::OnSocketEvent( wxSocketEvent &e )
{
	if( e.GetSocketEvent() == wxSOCKET_INPUT )
	{
		unsigned char buf[30000];

     	while(1)
		{
			int buf_len = SocketRead(buf, 30000);
			if(buf_len == 0)	break;

			unsigned char *e, *end;
			e = buf;
			end = buf + buf_len;
			while( e < end )	//ˬdݬ buf ̭S IAC (0xff)
			{
				if( *e == 0xff )	//IAC ( need to negotiation )
   				{
					SocketUnread( e , end - e );
      				break;
				}
				e++;
			}

			int unread_data_len;
			unread_data_len = parse( (char*)buf , e - buf );
			if( unread_data_len > 0 )	//pGƩ|R, h Unread
			{
				if( e < end && *e == 0xff );	//o楲n[AMJYǸƷ|iJLj ( Ҧp "\x1b[qqq\xff" )
				else SocketUnread( e - unread_data_len , unread_data_len );
			}

/*
wxString str = "";
for(unsigned char *r=buf;r<e;r++)	str += wxString::Format("%c", *r);
wxMessageBox(str);
*/

			if( e < end && *e == 0xff )	//pG server nD negotiation
				negotiation();
			else
			{
				if( need_to_autologin && buf_len > 100 )	//۰ʵnJ
				{
	    	  		need_to_autologin = false;
					if( ! username.IsEmpty() )
					{
						keyUp();	keyUp(); 	//⦸ [Up]
    	  				UserSend( (char*)( username.c_str()) ); keyEnter();
	      				UserSend( (char*)( password.c_str()) ); keyEnter();
					}
					if( ! message.IsEmpty() )	UserSend_spacial( message );

					OnLogined();
				}

				break;
			}

		}
	}

	else if( e.GetSocketEvent() == wxSOCKET_CONNECTION
			|| e.GetSocketEvent() == wxSOCKET_LOST )
	{
		connect_state = ( SocketIsConnected() ? 2 : 0 );
	}
	else
		wxMessageBox(_T("unknown socket event"));

	//] parent window Bzo socket event
	e.m_clientData = this;	// EvtHandler iHzL e.GetClientData() o this
	getParentWindow()->AddPendingEvent(e);
}

void SCD_Telnet::close()
{
	if( IsDisconnected() ) return;
	user_closed = true;
	CloseSocket();

	//ѩ sock.close() ä| SocketEvent, ҥHnʲ
	wxSocketEvent e(666);
	e.SetEventObject( &sock );
	e.m_event = wxSOCKET_LOST;
	e.m_clientData = SocketGetClientData();
	OnSocketEvent(e);
}

bool SCD_Telnet::reconnect()
{
	if( ! IsDisconnected() ) 	return false;
	return	connect(getIP(), getPort(), getName() , username , password , message );
}
bool SCD_Telnet::connect(wxString _ip , int _port , wxString _name
	, wxString _user = wxEmptyString , wxString _passwd = wxEmptyString , wxString _message = wxEmptyString )
{
	if( ! IsDisconnected() )	return false;
	UnIdleServer();
	UnIdleUser();

	//Mù
	wxWindow *parent = getParentWindow();
	setColumnRow( 80 , 24 );
	cleanScreen();
	if( parent && getVisible() )	repaint();

	//]w۰ʵnJ
 	username = _user;
 	password = _passwd;
	message = _message;
	need_to_autologin = true;
	blSupportNAWS = false;
	user_closed = false;

	//}lsu
	ip = _ip;
	port = _port;
	name = _name;

/*
	if( ! SocketConnect(addr, true) )
		wxMessageBox("Lksu");
	else
		start_time = wxGetLocalTime();
*/


	wxIPV4address addr;
	addr.Hostname(ip);
	addr.Service(port);
	connect_state = 1;
	SocketConnect(addr, false);

	start_time = wxGetLocalTime();


	return true;
}


// **************************************************** //
// **************************************************** //
// *************** 갵 telnet protocol *************** //
// **************************************************** //
// **************************************************** //



bool SCD_Telnet::negotiation()
{

//wqb telnet protocol |Ψ쪺O

#define IAC 	255     // interpret as command:
#define DONT    254     // you are not to use option
#define DO  	253     // please, you use option
#define WONT    252     // I won't use option
#define WILL    251     // I will use option
#define SB  	250     // interpret as subnegotiation
#define SE  	240

#define TELOPT_ECHO 1   /* echo */
#define TELOPT_SGA  3   /* suppress go ahead */

#define TELOPT_TTYPE    24  // terminal type
#define TELQUAL_IS  	0   // option is...
#define TELQUAL_SEND    1   // send option
#define TELOPT_SGA  	3   // suppress go ahead
#define TELOPT_NAWS 	31	// window size

#define ANY 128

enum telnet_state
{	TSDATA, TSIAC, TSDO, TSDONT, TSWILL, TSWONT, TSSB_START, TSSBIAC, TSSB_END, SB_TERMTYPE	};

enum telnet_func
{	FUNC_NOOP, FUNC_PUTC, FUNC_DO, FUNC_WILL, FUNC_WONT, FUNC_DONT, FUNC_END, FUNC_SB_TERMTYPE , FUNC_WILL_NAWS };

//wq state table
struct FSM_table
{
	telnet_state	now_state;		//ثeA
	unsigned char	input;			//ثe input r
	telnet_state	next_state;		//U@ӪA
	telnet_func		func;			//n檺ʧ@
};

static struct FSM_table neg_FSM[] =
{
	//	ثeA	input	U@ӪA	n檺ʧ@

	{	TSDATA,		IAC,	TSIAC,		FUNC_NOOP	},	//start negotiation
	{	TSDATA,		ANY,	TSDATA,		FUNC_END	},	//stop  negotiation

	//DO, DONT, WILL, WONT, SB
	{	TSIAC,		DO,		TSDO,		FUNC_NOOP	},
	{	TSIAC,		DONT,	TSDONT,		FUNC_NOOP	},
	{	TSIAC,		WILL,	TSWILL,		FUNC_NOOP	},
	{	TSIAC,		WONT,	TSWONT,		FUNC_NOOP	},
	{	TSIAC,		SB,		TSSB_START,	FUNC_NOOP	},
	{	TSIAC,		IAC,	TSDATA,		FUNC_PUTC	},
	{	TSIAC,		ANY,	TSDATA,		FUNC_NOOP	},

	{	TSDO,		TELOPT_TTYPE,	TSDATA,		FUNC_WILL		},	//IAC WILL TERMTYPE
	{	TSDO,		TELOPT_NAWS,	TSDATA,		FUNC_WILL_NAWS		},	//}Ҫù
	{	TSDO,		ANY,	TSDATA,		FUNC_WONT		},
	{	TSDONT,		ANY,	TSDATA,		FUNC_NOOP		},

	{	TSWILL,  	TELOPT_SGA,		TSDATA,		FUNC_DO	},	//suppress go ahead
	{	TSWILL,  	TELOPT_ECHO,	TSDATA,		FUNC_DO	},	//echo
	{	TSWILL,  	ANY,	TSDATA,		FUNC_DONT	},
	{	TSWONT,		ANY,	TSDATA,		FUNC_NOOP	},

	//U sub negotiation
	{	TSSB_START,	TELOPT_TTYPE,	SB_TERMTYPE,	FUNC_NOOP	},

	//sub negotiation common input
	{	TSSB_START,	IAC,	TSSBIAC,	FUNC_NOOP	},
	{	TSSB_START,	ANY,	TSSB_END,	FUNC_NOOP	},

	{	TSSB_END,	IAC,	TSSBIAC,	FUNC_NOOP	},
	{	TSSB_END,	ANY,	TSSB_END,	FUNC_NOOP	},

	{	TSSBIAC,	SE,		TSDATA,		FUNC_NOOP	},
	{	TSSBIAC,	ANY,	TSSB_END,	FUNC_NOOP	},

	//TERM_TYPE sub neg
	{	SB_TERMTYPE,	TELQUAL_SEND,	TSSB_END,	FUNC_SB_TERMTYPE	},
	{	SB_TERMTYPE,	ANY,			TSSB_END,	FUNC_NOOP	},

};



	//*** negotiation with server (telnet protocol) ***//




#ifdef DEBUG_NEGOTIATION

#include <stdio.h>
FILE *fp = NULL;

fp = fopen("log.txt", "w+");
fclose(fp);

fp = fopen("log.txt", "a+");
fprintf(fp, buf);
fclose(fp);

char map[256][30];
for(int i=0;i<256;i++)
	sprintf(map[i], "%02x", (unsigned char)i);
sprintf( map[IAC], "IAC" );
sprintf( map[DONT], "DONT" );
sprintf( map[DO], "DO  " );
sprintf( map[WONT], "WONT" );
sprintf( map[WILL], "WILL" );
sprintf( map[SB], "SB  " );
sprintf( map[SE], "SE  " );
sprintf( map[TELOPT_TTYPE], "TELOPT_TTYPE" );
sprintf( map[TELQUAL_IS], "TELQUAL_IS" );
sprintf( map[TELQUAL_SEND], "TELQUAL_SEND" );
sprintf( map[TELOPT_SGA], "TELOPT_SGA" );
sprintf( map[TELOPT_NAWS], "TELOPT_NAWS" );

char *state_name[] = {	"TSDATA", "TSIAC", "TSDO", "TSWILL", "TSSB_START", "TSSBIAC", "TSSB_END", "SB_TERMTYPE"	};
char *func_name[] = {	"FUNC_NOOP", "FUNC_PUTC", "FUNC_DO", "FUNC_WILL", "FUNC_WONT", "FUNC_DONT", "FUNC_END", "FUNC_SB_TERMTYPE"	};

wxLongLong  time_now = wxGetLocalTimeMillis(), time_diff;
fp = fopen("log.txt", "a+");
fclose(fp);

#endif

	//start negotiation

	enum telnet_state	now_state, next_state;
	enum telnet_func	func;
	unsigned char ch;

	now_state = TSDATA;


	while(1)
	{
		if( SocketRead( &ch, 1 ) != 1 )	//iO] non-blocking ӥBثeSƥiŪӳy error
    		return false;

		//q neg_FSM M
		for(int i=0;;i++)
		{
			if( neg_FSM[i].now_state == now_state )
				if( neg_FSM[i].input == ANY
    				|| neg_FSM[i].input == ch )
				{
     				next_state = neg_FSM[i].next_state;
     				func = neg_FSM[i].func;
					break;
				}
		}

#ifdef DEBUG_NEGOTIATION
fp = fopen("log.txt", "a+");

time_diff = wxGetLocalTimeMillis() - time_now;
fprintf(fp, "time=%-6s , ", time_diff.ToString().c_str() );
time_now += time_diff;

fprintf(fp, "now=%-13s , in=%-13s , next=%-13s , func=%-13s\n", state_name[now_state], map[ch], state_name[next_state], func_name[func] );
fclose(fp);
#endif
		now_state = next_state;

		//wʧ@

		if( func == FUNC_NOOP );
		else if( func == FUNC_WILL )
		{
			unsigned char tmp[3];
			tmp[0] = IAC;
			tmp[1] = WILL;
			tmp[2] = ch;
			SocketWrite(tmp, 3);
  		}
		else if( func == FUNC_DO )
		{
			unsigned char tmp[3];
			tmp[0] = IAC;
			tmp[1] = DO;
			tmp[2] = ch;
			SocketWrite(tmp, 3);
  		}
		else if( func == FUNC_WONT )
		{
			unsigned char tmp[3];
			tmp[0] = IAC;
			tmp[1] = WONT;
			tmp[2] = ch;
			SocketWrite(tmp, 3);
#ifdef DEBUG_NEGOTIATION
fp = fopen("log.txt", "a+");
fprintf(fp, "\nclient : ");
fprintf(fp, "%s ", map[ (unsigned char)tmp[0]]);
fprintf(fp, "%s ", map[ (unsigned char)tmp[1]]);
fprintf(fp, "%s\n\n", map[ (unsigned char)tmp[2]]);
fclose(fp);
#endif
		}
		else if( func == FUNC_DONT )
		{
			unsigned char tmp[3];
			tmp[0] = IAC;
			tmp[1] = DONT;
			tmp[2] = ch;
			SocketWrite(tmp, 3);
#ifdef DEBUG_NEGOTIATION
fp = fopen("log.txt", "a+");
fprintf(fp, "\nclient : ");
fprintf(fp, "%s ", map[ (unsigned char)tmp[0]]);
fprintf(fp, "%s ", map[ (unsigned char)tmp[1]]);
fprintf(fp, "%s\n\n", map[ (unsigned char)tmp[2]]);
fclose(fp);
#endif
		}
		else if( func == FUNC_SB_TERMTYPE )
		{
			unsigned char tmp[15];
			int i = 0;
			tmp[i++] = IAC;
			tmp[i++] = SB;
			tmp[i++] = TELOPT_TTYPE;
			tmp[i++] = TELQUAL_IS;
			tmp[i++] = 'v';
			tmp[i++] = 't';
			tmp[i++] = '1';
			tmp[i++] = '0';
			tmp[i++] = '0';
			tmp[i++] = IAC;
			tmp[i++] = SE;
			SocketWrite(tmp, i);
#ifdef DEBUG_NEGOTIATION
fp = fopen("log.txt", "a+");
fprintf(fp, "\nclient : ");
int t=0;
while(t<i)
	fprintf(fp, "%s ", map[ (unsigned char)tmp[t++]]);
fputs("\n", fp);
fclose(fp);
#endif
		}
		else if( func == FUNC_WILL_NAWS )
		{
			unsigned char tmp[3];
			tmp[0] = IAC;
			tmp[1] = WILL;
			tmp[2] = TELOPT_NAWS;
			SocketWrite(tmp, 3);
			OnServerSupportNAWS();
		}
		else if( func == FUNC_END )
  		{
  			SocketUnread( &ch , 1 );
    		break;
		}

	}
#ifdef DEBUG_NEGOTIATION
fp = fopen("log.txt", "a+");
fprintf(fp, "\ntelnet negotiation end\n");
fclose(fp);
#endif
	// ************************************************* //


#ifdef DEBUG_NEGOTIATION
while(1)
{
SocketRead( &ch , 1 );
fp = fopen("log.txt", "a+");
fprintf(fp, "%s ", map[ch]);
//fprintf(fp, "%c", ch);
fclose(fp);
}
#endif


	return true;
}

// ============================================================================

#endif
